import { Injectable, ɵɵdefineInjectable, Component, Inject, ɵɵinject, RendererFactory2, Input, Directive, ElementRef, Renderer2, HostListener, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { TranslateService, TranslateModule, TranslateLoader } from '@ngx-translate/core';
import { HttpHeaders, HttpClient, HttpClientModule } from '@angular/common/http';
import { NavigationStart, Router, ActivatedRoute } from '@angular/router';
import { Validators, FormBuilder, NgControl, FormsModule, ReactiveFormsModule } from '@angular/forms';
import { Observable } from 'rxjs';
import { sha256 } from 'js-sha256';
import { MultiTranslateHttpLoader } from 'ngx-translate-multi-http-loader';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/campaigns-core.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class CampaignsCoreService {
    constructor() { }
}
CampaignsCoreService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
CampaignsCoreService.ctorParameters = () => [];
/** @nocollapse */ CampaignsCoreService.ngInjectableDef = ɵɵdefineInjectable({ factory: function CampaignsCoreService_Factory() { return new CampaignsCoreService(); }, token: CampaignsCoreService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * Generated from: lib/campaigns-core.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class CampaignsCoreComponent {
    constructor() { }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
}
CampaignsCoreComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-campaigns-core',
                template: `
    <p>
      campaigns-core works!
    </p>
  `
            }] }
];
/** @nocollapse */
CampaignsCoreComponent.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * Generated from: lib/services/session.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class SessionService {
    /**
     * @param {?} http
     * @param {?} environment
     */
    constructor(http, environment) {
        this.http = http;
        this.environment = environment;
    }
    /**
     * @return {?}
     */
    postSession() {
        return this.http.post(`${this.environment.baseApi}/api/v1/sessions`, {});
    }
    /**
     * @param {?} session
     * @param {?} sessionId
     * @return {?}
     */
    patchSession(session, sessionId) {
        /** @type {?} */
        const httpHeaders = new HttpHeaders().set('Content-Type', 'application/merge-patch+json');
        return this.http.patch(`${this.environment.baseApi}/api/v1/sessions/${sessionId}`, session, { headers: httpHeaders });
    }
    /**
     * @param {?} sessionId
     * @return {?}
     */
    getSession(sessionId) {
        return this.http.get(`${this.environment.baseApi}/api/v1/sessions/${sessionId}`);
    }
}
SessionService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
SessionService.ctorParameters = () => [
    { type: HttpClient },
    { type: undefined, decorators: [{ type: Inject, args: ['environment',] }] }
];
/** @nocollapse */ SessionService.ngInjectableDef = ɵɵdefineInjectable({ factory: function SessionService_Factory() { return new SessionService(ɵɵinject(HttpClient), ɵɵinject("environment")); }, token: SessionService, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @private
     */
    SessionService.prototype.http;
    /**
     * @type {?}
     * @private
     */
    SessionService.prototype.environment;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/services/utils.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class UtilsService {
    /**
     * @param {?} http
     * @param {?} sessionService
     * @param {?} translate
     * @param {?} rendererFactory
     * @param {?} router
     * @param {?} route
     */
    constructor(http, sessionService, translate, rendererFactory, router, route) {
        this.http = http;
        this.sessionService = sessionService;
        this.translate = translate;
        this.rendererFactory = rendererFactory;
        this.router = router;
        this.route = route;
    }
    /**
     * @param {?} object
     * @param {...?} args
     * @return {?}
     */
    getNested(object, ...args) {
        return args.reduce((/**
         * @param {?} object
         * @param {?} level
         * @return {?}
         */
        (object, level) => object && object[level]), object);
    }
    /**
     * @return {?}
     */
    getIPAddress() {
        return this.http.get('http://api.ipify.org/?format=json');
    }
    /**
     * @return {?}
     */
    getSessionId() {
        /** @type {?} */
        const config = JSON.parse(localStorage.getItem('config'));
        if (config.id) {
            return config.id;
        }
        else {
            this.sessionService.postSession().subscribe((/**
             * @param {?} session
             * @return {?}
             */
            session => {
                localStorage.setItem('config', JSON.stringify(session));
                return session.id;
            }));
        }
    }
    /**
     * @return {?}
     */
    getSession() {
        /** @type {?} */
        const config = JSON.parse(localStorage.getItem('config'));
        if (config.id) {
            return config;
        }
        else {
            this.sessionService.postSession().subscribe((/**
             * @param {?} session
             * @return {?}
             */
            session => {
                localStorage.setItem('config', JSON.stringify(session));
                return session;
            }));
        }
    }
    /**
     * @return {?}
     */
    setRoutClassOnBody() {
        this.renderer = this.rendererFactory.createRenderer(null, null);
        this.router.events.subscribe((/**
         * @param {?} event
         * @return {?}
         */
        (event) => {
            if (event instanceof NavigationStart) {
                /** @type {?} */
                let currentUrlSlug = event.url.slice(1);
                currentUrlSlug = currentUrlSlug.split('?');
                console.log("Mdrrr", currentUrlSlug);
                if (currentUrlSlug) {
                    this.renderer.addClass(document.body, `geo-${currentUrlSlug[0]}`);
                    this.translate.use(currentUrlSlug[0]);
                    console.log("TESTTT", currentUrlSlug[0]);
                }
                this.route.queryParams.subscribe((/**
                 * @param {?} params
                 * @return {?}
                 */
                params => {
                    if (params.lang) {
                        console.log("Mdrrr");
                        this.renderer.addClass(document.body, `lang-${params.lang}`);
                        this.translate.use(params.lang);
                    }
                }));
            }
        }));
    }
    /**
     * @return {?}
     */
    setDefaultTranslation() {
        this.translate.setDefaultLang('us');
    }
    /**
     * @return {?}
     */
    setCakeParams() {
        /** @type {?} */
        const cake = {
            r: null,
            o: null,
            a: null,
            sa: null
        };
        this.route.queryParams.subscribe((/**
         * @param {?} params
         * @return {?}
         */
        params => {
            if (params.r)
                cake.r = params.r;
            if (params.o)
                cake.o = params.o;
            if (params.a)
                cake.a = params.a;
            if (params.sa)
                cake.sa = params.sa;
            localStorage.setItem('params', JSON.stringify(cake));
        }));
    }
    /**
     * @return {?}
     */
    setConfigSession() {
        /** @type {?} */
        let config = localStorage.getItem('config');
        if (config !== null && config !== '') {
            config = JSON.parse(config);
        }
        if (config === null || !config['campaign']) {
            this.sessionService.postSession().subscribe((/**
             * @param {?} session
             * @return {?}
             */
            session => {
                localStorage.setItem('config', JSON.stringify(session));
            }));
        }
    }
}
UtilsService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
UtilsService.ctorParameters = () => [
    { type: HttpClient },
    { type: SessionService },
    { type: TranslateService },
    { type: RendererFactory2 },
    { type: Router },
    { type: ActivatedRoute }
];
/** @nocollapse */ UtilsService.ngInjectableDef = ɵɵdefineInjectable({ factory: function UtilsService_Factory() { return new UtilsService(ɵɵinject(HttpClient), ɵɵinject(SessionService), ɵɵinject(TranslateService), ɵɵinject(RendererFactory2), ɵɵinject(Router), ɵɵinject(ActivatedRoute)); }, token: UtilsService, providedIn: "root" });
if (false) {
    /** @type {?} */
    UtilsService.prototype.renderer;
    /**
     * @type {?}
     * @private
     */
    UtilsService.prototype.http;
    /**
     * @type {?}
     * @private
     */
    UtilsService.prototype.sessionService;
    /**
     * @type {?}
     * @private
     */
    UtilsService.prototype.translate;
    /**
     * @type {?}
     * @private
     */
    UtilsService.prototype.rendererFactory;
    /**
     * @type {?}
     * @private
     */
    UtilsService.prototype.router;
    /**
     * @type {?}
     * @private
     */
    UtilsService.prototype.route;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/services/config-info.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ConfigInfoService {
    /**
     * @param {?} sessionService
     * @param {?} utilsService
     */
    constructor(sessionService, utilsService) {
        this.sessionService = sessionService;
        this.utilsService = utilsService;
    }
    /**
     * @param {...?} args
     * @return {?}
     */
    getConfigInfo(...args) {
        /** @type {?} */
        const config = JSON.parse(localStorage.getItem('config'));
        if (config !== null && config !== '' && this.utilsService.getNested(config, ...args)) {
            return (this.getConfigValue(args, config));
        }
        else {
            this.sessionService.postSession().subscribe((/**
             * @param {?} session
             * @return {?}
             */
            session => {
                localStorage.setItem('config', JSON.stringify(session));
                return (this.getConfigValue(args, config));
            }));
        }
    }
    /**
     * @param {?} args
     * @param {?} config
     * @return {?}
     */
    getConfigValue(args, config) {
        args.forEach((/**
         * @param {?} val
         * @return {?}
         */
        val => {
            config = config[val];
        }));
        return config;
    }
    /**
     * @return {?}
     */
    getCurrentYear() {
        return new Date().getFullYear();
    }
}
ConfigInfoService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
ConfigInfoService.ctorParameters = () => [
    { type: SessionService },
    { type: UtilsService }
];
/** @nocollapse */ ConfigInfoService.ngInjectableDef = ɵɵdefineInjectable({ factory: function ConfigInfoService_Factory() { return new ConfigInfoService(ɵɵinject(SessionService), ɵɵinject(UtilsService)); }, token: ConfigInfoService, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @private
     */
    ConfigInfoService.prototype.sessionService;
    /**
     * @type {?}
     * @private
     */
    ConfigInfoService.prototype.utilsService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/services/validation-form.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ValidationFormService {
    /**
     * @param {?} sessionService
     * @param {?} utilsService
     */
    constructor(sessionService, utilsService) {
        this.sessionService = sessionService;
        this.utilsService = utilsService;
    }
    /**
     * @param {?} control
     * @return {?}
     */
    static emailValidator(control) {
        // RFC 2822 compliant regex
        if (control.value.match(/[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?/)) {
            return null;
        }
        else {
            return { invalidEmailAddress: true };
        }
    }
    /**
     * @param {?} control
     * @return {?}
     */
    static firstNameValidator(control) {
        // RFC 2822 compliant regex
        if (control.value.match(/^[a-zA-Z]+$/)) {
            return null;
        }
        else {
            return { invalidFirstName: true };
        }
    }
    /**
     * @param {?} control
     * @return {?}
     */
    static lastNameValidator(control) {
        // RFC 2822 compliant regex
        if (control.value.match(/^[a-zA-Z]+$/)) {
            return null;
        }
        else {
            return { invalidLastName: true };
        }
    }
    /**
     * @param {?} control
     * @return {?}
     */
    static cityValidator(control) {
        // RFC 2822 compliant regex
        if (control.value.match(/^[a-zA-Z]+$/)) {
            return null;
        }
        else {
            return { invalidCity: true };
        }
    }
    /**
     * @param {?} signupForm
     * @param {?} sessionId
     * @return {?}
     */
    verifAndPatchSession(signupForm, sessionId) {
        return new Observable((/**
         * @param {?} observer
         * @return {?}
         */
        observer => {
            /** @type {?} */
            let prospect = signupForm.value;
            this.utilsService.getIPAddress().subscribe((/**
             * @param {?} ip
             * @return {?}
             */
            ip => {
                prospect.prospect['ip'] = ip.ip;
                /** @type {?} */
                const cake = this.getCakeParams();
                prospect.affiliate = cake;
                this.sessionService.patchSession(prospect, sessionId).subscribe((/**
                 * @param {?} session
                 * @return {?}
                 */
                session => {
                    this.sessionService.getSession(sessionId).subscribe((/**
                     * @param {?} session
                     * @return {?}
                     */
                    session => {
                        localStorage.setItem('config', JSON.stringify(session));
                        observer.next(true);
                        observer.complete();
                    }));
                }), (/**
                 * @param {?} error
                 * @return {?}
                 */
                error => {
                    /** @type {?} */
                    let errorMessage = JSON.parse(error.error.detail)[0].message;
                    this.sessionService.getSession(sessionId).subscribe((/**
                     * @param {?} session
                     * @return {?}
                     */
                    session => {
                        localStorage.setItem('config', JSON.stringify(session));
                        observer.error(errorMessage);
                        observer.complete();
                    }));
                }));
            }));
        }));
    }
    /**
     * @return {?}
     */
    getCakeParams() {
        /** @type {?} */
        let cake = localStorage.getItem('params');
        if (cake !== null && cake !== '') {
            cake = JSON.parse(cake);
        }
        return cake;
    }
    /**
     * @param {?} signupForm
     * @return {?}
     */
    checkHistoryEmail(signupForm) {
        /** @type {?} */
        const session = this.utilsService.getSession();
        if (this.validationEmail(session.zBEmailValidations, signupForm) === true && this.validationEmail(session.mFEmailValidations, signupForm) === true)
            return true;
        else
            return false;
    }
    /**
     * @param {?} zeroBouce
     * @param {?} signupForm
     * @return {?}
     */
    validationEmail(zeroBouce, signupForm) {
        /** @type {?} */
        let valid = true;
        zeroBouce.forEach((/**
         * @param {?} value
         * @return {?}
         */
        (value) => {
            if (sha256(signupForm.value.prospect.email) === value.hash && value.valid === false)
                valid = false;
        }));
        return valid;
    }
}
ValidationFormService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
ValidationFormService.ctorParameters = () => [
    { type: SessionService },
    { type: UtilsService }
];
/** @nocollapse */ ValidationFormService.ngInjectableDef = ɵɵdefineInjectable({ factory: function ValidationFormService_Factory() { return new ValidationFormService(ɵɵinject(SessionService), ɵɵinject(UtilsService)); }, token: ValidationFormService, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @private
     */
    ValidationFormService.prototype.sessionService;
    /**
     * @type {?}
     * @private
     */
    ValidationFormService.prototype.utilsService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/components/signup/signup.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class SignupComponent {
    /**
     * @param {?} formBuilder
     * @param {?} route
     * @param {?} translate
     * @param {?} configInfoService
     * @param {?} validationService
     */
    constructor(formBuilder, route, translate, configInfoService, validationService) {
        this.formBuilder = formBuilder;
        this.route = route;
        this.translate = translate;
        this.configInfoService = configInfoService;
        this.validationService = validationService;
        this.country = this.route.snapshot.routeConfig.path.toUpperCase();
        this.signupForm = this.formBuilder.group({
            'prospect': this.formBuilder.group({
                'firstName': ['', [Validators.required, ValidationFormService.firstNameValidator, Validators.minLength(2), Validators.maxLength(255)]],
                'lastName': ['', [Validators.required, ValidationFormService.lastNameValidator, Validators.minLength(2), Validators.maxLength(255)]],
                'phone': ['', [Validators.required, Validators.minLength(6), Validators.maxLength(20)]],
                'email': ['', [Validators.required, Validators.email, ValidationFormService.emailValidator, Validators.minLength(4), Validators.maxLength(255)]],
                'address': this.formBuilder.group({
                    'postcode': ['', [Validators.required, Validators.minLength(2), Validators.maxLength(20)]],
                    'city': ['', [Validators.required, ValidationFormService.cityValidator, Validators.minLength(2), Validators.maxLength(255)]],
                    'street': ['', [Validators.required, Validators.minLength(2), Validators.maxLength(255)]],
                    'country': [this.country],
                })
            })
        });
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.country = this.route.snapshot.routeConfig.path.toUpperCase();
        this.preFiledInfo();
    }
    /**
     * @return {?}
     */
    preFiledInfo() {
        /** @type {?} */
        const config = JSON.parse(localStorage.getItem('config'));
        if (config !== null && config !== '' && config.prospect) {
            this.signupForm.controls.prospect.patchValue({
                "firstName": this.configInfoService.getConfigInfo('prospect', 'firstName'),
                "lastName": this.configInfoService.getConfigInfo('prospect', 'lastName'),
                "phone": this.configInfoService.getConfigInfo('prospect', 'phone'),
                "email": this.configInfoService.getConfigInfo('prospect', 'email'),
                "address": {
                    "city": this.configInfoService.getConfigInfo('prospect', 'address', 'city'),
                    "postcode": this.configInfoService.getConfigInfo('prospect', 'address', 'postcode'),
                    "street": this.configInfoService.getConfigInfo('prospect', 'address', 'street'),
                }
            });
        }
    }
    /**
     * @return {?}
     */
    patchSession() {
        this.errorMessage = null;
        this.sessionId = this.configInfoService.getConfigInfo('id');
        if (this.signupForm.dirty && this.signupForm.valid && this.validationService.checkHistoryEmail(this.signupForm) === true) {
            this.validationService.verifAndPatchSession(this.signupForm, this.sessionId).subscribe((/**
             * @param {?} session
             * @return {?}
             */
            session => {
                /** @type {?} */
                let redirectionUrl = this.configInfoService.getConfigInfo('campaign', 'offers', [0], 'brands', [1], 'domain');
                window.location.href = `https://${redirectionUrl}/payment/${this.sessionId}`;
            }), (/**
             * @param {?} error
             * @return {?}
             */
            error => {
                this.errorMessage = error;
            }));
        }
        else
            this.errorMessage = 'An error occurred';
    }
}
SignupComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-signup',
                template: "<div class=\"form-signup-wrapper\">\n  <form [formGroup]=\"signupForm\" (ngSubmit)=\"patchSession()\" class=\"form form-signup\">\n    <div formGroupName=\"prospect\" class=\"prospect-wrapper\">\n      <div class=\"name-group field-group\">\n        <div class=\"first-name field form-group\">\n          <label for=\"firstName\" class=\"first-name-label label\">{{ 'signup.label.firstname' | translate }}</label>\n          <input type=\"text\" class=\"first-name-input form-control\" id=\"firstName\" placeholder=\"{{ 'signup.placeholder.firstname' | translate }}\" formControlName=\"firstName\" required>\n          <lib-control-messages [control]=\"signupForm.get(['prospect', 'firstName'])\"></lib-control-messages>\n        </div>\n        <div class=\"lastName form-group field\">\n          <label for=\"lastName\" class=\"last-name-label label\">{{ 'signup.label.lastname' | translate }}</label>\n          <input type=\"text\" class=\"last-name-input form-control\" id=\"lastName\" placeholder=\"{{ 'signup.placeholder.lastname' | translate }}\" formControlName=\"lastName\" required>\n          <lib-control-messages [control]=\"signupForm.get(['prospect', 'lastName'])\"></lib-control-messages>\n        </div>\n      </div>\n      <div formGroupName=\"address\" class=\"address-group field-group\">\n        <div class=\"address form-group field\">\n          <label for=\"street\" class=\"address-label label\">{{ 'signup.label.address' | translate }}</label>\n          <input type=\"text\" class=\"address-input form-control\" id=\"street\" placeholder=\"Address\" formControlName=\"street\" required specialIsAlphaNumeric>\n          <lib-control-messages [control]=\"signupForm.get(['prospect', 'address', 'street'])\"></lib-control-messages>\n        </div>\n        <div class=\"postcode form-group field\">\n          <label for=\"postcode\" class=\"postcode-label label\">{{ 'signup.label.postcode' | translate }}</label>\n          <input type=\"text\" class=\"postcode-input form-control\" id=\"postcode\" placeholder=\"{{ 'signup.placeholder.postcode' | translate }}\" formControlName=\"postcode\" required specialIsAlphaNumeric>\n          <lib-control-messages [control]=\"signupForm.get(['prospect', 'address', 'postcode'])\"></lib-control-messages>\n        </div>\n        <div class=\"city form-group field\">\n          <label for=\"city\" class=\"city-label label\">{{ 'signup.label.city' | translate }}</label>\n          <input type=\"text\" class=\"city-input form-control\" id=\"city\" placeholder=\"{{ 'signup.placeholder.city' | translate }}\" formControlName=\"city\" required specialIsAlphaNumeric>\n          <lib-control-messages [control]=\"signupForm.get(['prospect', 'address', 'city'])\"></lib-control-messages>\n        </div>\n      </div>\n      <div class=\"contact-group field-group\">\n        <div class=\"phone form-group field\">\n          <label for=\"phone\" class=\"phone-label label\">{{ 'signup.label.phone' | translate }}</label>\n          <input type=\"text\" class=\"phone-input form-control\" id=\"phone\" placeholder=\"{{ 'signup.placeholder.phone' | translate }}\" formControlName=\"phone\" required phoneNumeric>\n          <lib-control-messages [control]=\"signupForm.get(['prospect', 'phone'])\"></lib-control-messages>\n        </div>\n        <div class=\"email form-group field\">\n          <label for=\"email\" class=\"email-label label\">{{ 'signup.label.email' | translate }}</label>\n          <input type=\"text\" class=\"email-input form-control\" id=\"email\" placeholder=\"{{ 'signup.placeholder.email' | translate }}\" formControlName=\"email\" required>\n          <lib-control-messages [control]=\"signupForm.get(['prospect', 'email'])\"></lib-control-messages>\n        </div>\n      </div>\n      <div class=\"buttons form-group field-submit\">\n        <button type=\"submit\" class=\"button button-submit\" [disabled]=\"!signupForm.valid\">{{ 'signup.button' | translate }}</button>\n      </div>\n    </div>\n  </form>\n</div>\n",
                styles: ["button{width:100%}"]
            }] }
];
/** @nocollapse */
SignupComponent.ctorParameters = () => [
    { type: FormBuilder },
    { type: ActivatedRoute },
    { type: TranslateService },
    { type: ConfigInfoService },
    { type: ValidationFormService }
];
if (false) {
    /** @type {?} */
    SignupComponent.prototype.sessionId;
    /** @type {?} */
    SignupComponent.prototype.session;
    /** @type {?} */
    SignupComponent.prototype.country;
    /** @type {?} */
    SignupComponent.prototype.errorMessage;
    /** @type {?} */
    SignupComponent.prototype.signupForm;
    /**
     * @type {?}
     * @private
     */
    SignupComponent.prototype.formBuilder;
    /**
     * @type {?}
     * @private
     */
    SignupComponent.prototype.route;
    /**
     * @type {?}
     * @private
     */
    SignupComponent.prototype.translate;
    /**
     * @type {?}
     * @private
     */
    SignupComponent.prototype.configInfoService;
    /**
     * @type {?}
     * @private
     */
    SignupComponent.prototype.validationService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/services/company-info.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class CompanyInfoService {
    constructor() { }
    /**
     * @return {?}
     */
    getYear() {
        return "2020";
    }
    /**
     * @return {?}
     */
    getDomain() {
        return "domain";
    }
    /**
     * @return {?}
     */
    getCity() {
        return "Dubai";
    }
    /**
     * @return {?}
     */
    getCountry() {
        return "UAE";
    }
    /**
     * @return {?}
     */
    getState() {
        return "JVC";
    }
    /**
     * @return {?}
     */
    getTags() {
        return "bla bla bla";
    }
}
CompanyInfoService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
CompanyInfoService.ctorParameters = () => [];
/** @nocollapse */ CompanyInfoService.ngInjectableDef = ɵɵdefineInjectable({ factory: function CompanyInfoService_Factory() { return new CompanyInfoService(); }, token: CompanyInfoService, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @protected
     */
    CompanyInfoService.prototype.year;
    /**
     * @type {?}
     * @protected
     */
    CompanyInfoService.prototype.domain;
    /**
     * @type {?}
     * @protected
     */
    CompanyInfoService.prototype.city;
    /**
     * @type {?}
     * @protected
     */
    CompanyInfoService.prototype.country;
    /**
     * @type {?}
     * @protected
     */
    CompanyInfoService.prototype.state;
    /**
     * @type {?}
     * @protected
     */
    CompanyInfoService.prototype.tags;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/environments/environment.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// This file can be replaced during build by using the `fileReplacements` array.
// `ng build --prod` replaces `environment.ts` with `environment.prod.ts`.
// The list of file replacements can be found in `angular.json`.
/** @type {?} */
const environment = {
    production: false,
    baseApi: 'http://landing-staging.thelmit.com'
};

/**
 * @fileoverview added by tsickle
 * Generated from: lib/components/config-info/initial-period/initial-period.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class InitialPeriodComponent {
    /**
     * @param {?} sessionService
     * @param {?} utilsService
     */
    constructor(sessionService, utilsService) {
        this.sessionService = sessionService;
        this.utilsService = utilsService;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.getInitialPeriod();
    }
    /**
     * @return {?}
     */
    getInitialPeriod() {
        /** @type {?} */
        const config = JSON.parse(localStorage.getItem('config'));
        if (this.utilsService.getNested(config, 'campaign', 'offers', [0], 'products', [0], 'installments', [0], 'cycle', 'count') &&
            this.utilsService.getNested(config, 'campaign', 'offers', [0], 'products', [0], 'installments', [0], 'cycle', 'type')) {
            this.initialPeriod = `${config.campaign.offers[0].products[0].installments[0].cycle.count} ${config.campaign.offers[0].products[0].installments[0].cycle.type}`;
        }
        else {
            this.sessionService.postSession().subscribe((/**
             * @param {?} session
             * @return {?}
             */
            session => {
                localStorage.setItem('config', JSON.stringify(session));
                this.initialPeriod = `${session.campaign.offers[0].products[0].installments[0].cycle.count} ${session.campaign.offers[0].products[0].installments[0].cycle.type}`;
            }));
        }
    }
}
InitialPeriodComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-initial-period',
                template: '{{initialPeriod}}'
            }] }
];
/** @nocollapse */
InitialPeriodComponent.ctorParameters = () => [
    { type: SessionService },
    { type: UtilsService }
];
if (false) {
    /** @type {?} */
    InitialPeriodComponent.prototype.initialPeriod;
    /**
     * @type {?}
     * @private
     */
    InitialPeriodComponent.prototype.sessionService;
    /**
     * @type {?}
     * @private
     */
    InitialPeriodComponent.prototype.utilsService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/components/config-info/initial-price/initial-price.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class InitialPriceComponent {
    /**
     * @param {?} sessionService
     * @param {?} utilsService
     */
    constructor(sessionService, utilsService) {
        this.sessionService = sessionService;
        this.utilsService = utilsService;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.getInitialPrice();
    }
    /**
     * @return {?}
     */
    getInitialPrice() {
        /** @type {?} */
        const config = JSON.parse(localStorage.getItem('config'));
        if (this.utilsService.getNested(config, 'campaign', 'offers', [0], 'products', [0], 'installments', [0], 'price')) {
            this.initialPrice = config.campaign.offers[0].products[0].installments[0].price;
        }
        else {
            this.sessionService.postSession().subscribe((/**
             * @param {?} session
             * @return {?}
             */
            session => {
                localStorage.setItem('config', JSON.stringify(session));
                this.initialPrice = session.campaign.offers[0].products[0].installments[0].price;
            }));
        }
    }
}
InitialPriceComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-initial-price',
                template: '{{initialPrice}}'
            }] }
];
/** @nocollapse */
InitialPriceComponent.ctorParameters = () => [
    { type: SessionService },
    { type: UtilsService }
];
if (false) {
    /** @type {?} */
    InitialPriceComponent.prototype.initialPrice;
    /**
     * @type {?}
     * @private
     */
    InitialPriceComponent.prototype.sessionService;
    /**
     * @type {?}
     * @private
     */
    InitialPriceComponent.prototype.utilsService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/components/config-info/re-bill-price/re-bill-price.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ReBillPriceComponent {
    /**
     * @param {?} sessionService
     * @param {?} utilsService
     */
    constructor(sessionService, utilsService) {
        this.sessionService = sessionService;
        this.utilsService = utilsService;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.getReBillPrice();
    }
    /**
     * @return {?}
     */
    getReBillPrice() {
        /** @type {?} */
        const config = JSON.parse(localStorage.getItem('config'));
        if (this.utilsService.getNested(config, 'campaign', 'offers', [0], 'products', [0], 'installments', [1], 'price')) {
            this.reBillPrice = config.campaign.offers[0].products[0].installments[1].price;
        }
        else {
            this.sessionService.postSession().subscribe((/**
             * @param {?} session
             * @return {?}
             */
            session => {
                localStorage.setItem('config', JSON.stringify(session));
                this.reBillPrice = session.campaign.offers[0].products[0].installments[1].price;
            }));
        }
    }
}
ReBillPriceComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-re-bill-price',
                template: '{{reBillPrice}}'
            }] }
];
/** @nocollapse */
ReBillPriceComponent.ctorParameters = () => [
    { type: SessionService },
    { type: UtilsService }
];
if (false) {
    /** @type {?} */
    ReBillPriceComponent.prototype.reBillPrice;
    /**
     * @type {?}
     * @private
     */
    ReBillPriceComponent.prototype.sessionService;
    /**
     * @type {?}
     * @private
     */
    ReBillPriceComponent.prototype.utilsService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/components/config-info/re-bill-period/re-bill-period.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ReBillPeriodComponent {
    /**
     * @param {?} sessionService
     * @param {?} utilsService
     */
    constructor(sessionService, utilsService) {
        this.sessionService = sessionService;
        this.utilsService = utilsService;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.getReBillPeriod();
    }
    /**
     * @return {?}
     */
    getReBillPeriod() {
        /** @type {?} */
        const config = JSON.parse(localStorage.getItem('config'));
        if (this.utilsService.getNested(config, 'campaign', 'offers', [0], 'products', [0], 'installments', [1], 'cycle', 'count') &&
            this.utilsService.getNested(config, 'campaign', 'offers', [0], 'products', [0], 'installments', [1], 'cycle', 'type')) {
            this.reBillPeriod = `${config.campaign.offers[0].products[0].installments[1].cycle.count} ${config.campaign.offers[0].products[0].installments[1].cycle.type}`;
        }
        else {
            this.sessionService.postSession().subscribe((/**
             * @param {?} session
             * @return {?}
             */
            session => {
                localStorage.setItem('config', JSON.stringify(session));
                this.reBillPeriod = `${session.campaign.offers[0].products[0].installments[1].cycle.count} ${session.campaign.offers[0].products[0].installments[1].cycle.type}`;
            }));
        }
    }
}
ReBillPeriodComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-re-bill-period',
                template: '{{reBillPeriod}}'
            }] }
];
/** @nocollapse */
ReBillPeriodComponent.ctorParameters = () => [
    { type: SessionService },
    { type: UtilsService }
];
if (false) {
    /** @type {?} */
    ReBillPeriodComponent.prototype.reBillPeriod;
    /**
     * @type {?}
     * @private
     */
    ReBillPeriodComponent.prototype.sessionService;
    /**
     * @type {?}
     * @private
     */
    ReBillPeriodComponent.prototype.utilsService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/components/config-info/currency/currency.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class CurrencyComponent {
    /**
     * @param {?} sessionService
     * @param {?} utilsService
     */
    constructor(sessionService, utilsService) {
        this.sessionService = sessionService;
        this.utilsService = utilsService;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.getCurrency();
    }
    /**
     * @return {?}
     */
    getCurrency() {
        /** @type {?} */
        const config = JSON.parse(localStorage.getItem('config'));
        if (this.utilsService.getNested(config, 'campaign', 'currency')) {
            this.currency = config.campaign.currency;
        }
        else {
            this.sessionService.postSession().subscribe((/**
             * @param {?} session
             * @return {?}
             */
            session => {
                localStorage.setItem('config', JSON.stringify(session));
                this.currency = session.campaign.currency;
            }));
        }
    }
}
CurrencyComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-currency',
                template: '{{currency}}'
            }] }
];
/** @nocollapse */
CurrencyComponent.ctorParameters = () => [
    { type: SessionService },
    { type: UtilsService }
];
if (false) {
    /** @type {?} */
    CurrencyComponent.prototype.currency;
    /**
     * @type {?}
     * @private
     */
    CurrencyComponent.prototype.sessionService;
    /**
     * @type {?}
     * @private
     */
    CurrencyComponent.prototype.utilsService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/components/config-info/current-year/current-year.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class CurrentYearComponent {
    constructor() { }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.year = (new Date()).getFullYear();
    }
}
CurrentYearComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-current-year',
                template: '{{year}}'
            }] }
];
/** @nocollapse */
CurrentYearComponent.ctorParameters = () => [];
if (false) {
    /** @type {?} */
    CurrentYearComponent.prototype.year;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/components/config-info/config-info.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ConfigInfoComponent {
    constructor() { }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
}
ConfigInfoComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-config-info',
                template: ''
            }] }
];
/** @nocollapse */
ConfigInfoComponent.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * Generated from: lib/components/signup-two/signup-two.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class SignupTwoComponent {
    /**
     * @param {?} fb
     * @param {?} route
     * @param {?} configInfoService
     * @param {?} validationService
     */
    constructor(fb, route, configInfoService, validationService) {
        this.fb = fb;
        this.route = route;
        this.configInfoService = configInfoService;
        this.validationService = validationService;
        this.country = this.route.snapshot.routeConfig.path.toUpperCase();
        this.signupForm = this.fb.group({
            'prospect': this.fb.group({
                'firstName': ['', [Validators.required, ValidationFormService.firstNameValidator, Validators.minLength(2), Validators.maxLength(255)]],
                'lastName': ['', [Validators.required, ValidationFormService.lastNameValidator, Validators.minLength(2), Validators.maxLength(255)]],
                'phone': ['', [Validators.required, Validators.minLength(6), Validators.maxLength(20)]],
                'email': ['', [Validators.required, Validators.email, ValidationFormService.emailValidator, Validators.minLength(4), Validators.maxLength(255)]],
                'address': this.fb.group({
                    'postcode': ['', [Validators.required, Validators.minLength(2), Validators.maxLength(20)]],
                    'street': ['', [Validators.required, Validators.minLength(2), Validators.maxLength(255)]],
                    'state': ['', [Validators.required, Validators.minLength(2), Validators.maxLength(255)]],
                    'country': [this.country],
                })
            })
        });
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.country = this.route.snapshot.routeConfig.path.toUpperCase();
        this.preFiledInfo();
    }
    /**
     * @return {?}
     */
    preFiledInfo() {
        /** @type {?} */
        const config = JSON.parse(localStorage.getItem('config'));
        if (config !== null && config !== '' && config.prospect) {
            this.signupForm.controls.prospect.patchValue({
                "firstName": this.configInfoService.getConfigInfo('prospect', 'firstName'),
                "lastName": this.configInfoService.getConfigInfo('prospect', 'lastName'),
                "phone": this.configInfoService.getConfigInfo('prospect', 'phone'),
                "email": this.configInfoService.getConfigInfo('prospect', 'email'),
                "address": {
                    "postcode": this.configInfoService.getConfigInfo('prospect', 'address', 'postcode'),
                    "street": this.configInfoService.getConfigInfo('prospect', 'address', 'street'),
                    "state": this.configInfoService.getConfigInfo('prospect', 'address', 'state')
                }
            });
        }
    }
    /**
     * @return {?}
     */
    patchSession() {
        this.errorMessage = null;
        this.sessionId = this.configInfoService.getConfigInfo('id');
        if (this.signupForm.dirty && this.signupForm.valid && this.validationService.checkHistoryEmail(this.signupForm) === true) {
            this.validationService.verifAndPatchSession(this.signupForm, this.sessionId).subscribe((/**
             * @param {?} session
             * @return {?}
             */
            session => {
                /** @type {?} */
                let redirectionUrl = this.configInfoService.getConfigInfo('campaign', 'offers', [0], 'brands', [1], 'domain');
                window.location.href = `https://${redirectionUrl}/payment/${this.sessionId}`;
            }), (/**
             * @param {?} error
             * @return {?}
             */
            error => {
                this.errorMessage = error;
            }));
        }
        else
            this.errorMessage = 'An error occurred';
    }
}
SignupTwoComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-signup-two',
                template: "<div class=\"form-signup-two-wrapper\">\n  <form [formGroup]=\"signupForm\" (ngSubmit)=\"patchSession()\" class=\"form form-signup-two\">\n    <div formGroupName=\"prospect\" class=\"prospect-wrapper\">\n      <div class=\"name-group field-group\">\n        <div class=\"first-name field form-group\">\n          <label for=\"firstName\" class=\"first-name-label label\">{{ 'signup.label.firstname' | translate }}</label>\n          <input type=\"text\" class=\"first-name-input form-control\" id=\"firstName\" placeholder=\"{{ 'signup.placeholder.firstname' | translate }}\" formControlName=\"firstName\" required>\n          <lib-control-messages [control]=\"signupForm.get(['prospect', 'firstName'])\"></lib-control-messages>\n        </div>\n        <div class=\"lastName form-group field\">\n          <label for=\"lastName\" class=\"last-name-label label\">{{ 'signup.label.lastname' | translate }}</label>\n          <input type=\"text\" class=\"last-name-input form-control\" id=\"lastName\" placeholder=\"{{ 'signup.placeholder.lastname' | translate }}\" formControlName=\"lastName\" required>\n          <lib-control-messages [control]=\"signupForm.get(['prospect', 'lastName'])\"></lib-control-messages>\n        </div>\n      </div>\n      <div formGroupName=\"address\" class=\"address-group field-group\">\n        <div class=\"address form-group field\">\n          <label for=\"street\" class=\"address-label label\">{{ 'signup.label.address' | translate }}</label>\n          <input type=\"text\" class=\"address-input form-control\" id=\"street\" placeholder=\"{{ 'signup.placeholder.address' | translate }}\" formControlName=\"street\" required specialIsAlphaNumeric>\n          <lib-control-messages [control]=\"signupForm.get(['prospect', 'address', 'street'])\"></lib-control-messages>\n        </div>\n        <div class=\"postcode form-group field\">\n          <label for=\"postcode\" class=\"postcode-label label\">{{ 'signup.label.postcode' | translate }}</label>\n          <input type=\"text\" class=\"postcode-input form-control\" id=\"postcode\" placeholder=\"{{ 'signup.placeholder.postcode' | translate }}\" formControlName=\"postcode\" required specialIsAlphaNumeric>\n          <lib-control-messages [control]=\"signupForm.get(['prospect', 'address', 'postcode'])\"></lib-control-messages>\n        </div>\n        <div class=\"state form-group field\">\n          <label for=\"state\" class=\"state-label label\">{{ 'signup.label.state' | translate }}</label>\n          <input type=\"text\" class=\"state-input form-control\" id=\"state\" placeholder=\"{{ 'signup.placeholder.state' | translate }}\" formControlName=\"state\" required specialIsAlphaNumeric>\n          <lib-control-messages [control]=\"signupForm.get(['prospect', 'address', 'state'])\"></lib-control-messages>\n        </div>\n      </div>\n      <div class=\"contact-group field-group\">\n        <div class=\"phone form-group field\">\n          <label for=\"phone\" class=\"phone-label label\">{{ 'signup.label.phone' | translate }}</label>\n          <input type=\"text\" class=\"phone-input form-control\" id=\"phone\" placeholder=\"{{ 'signup.placeholder.phone' | translate }}\" formControlName=\"phone\" required phoneNumeric>\n          <lib-control-messages [control]=\"signupForm.get(['prospect', 'phone'])\"></lib-control-messages>\n        </div>\n        <div class=\"email form-group field\">\n          <label for=\"email\" class=\"email-label label\">{{ 'signup.label.email' | translate }}</label>\n          <input type=\"text\" class=\"email-input form-control\" id=\"email\" placeholder=\"{{ 'signup.placeholder.email' | translate }}\" formControlName=\"email\" required>\n          <lib-control-messages [control]=\"signupForm.get(['prospect', 'email'])\"></lib-control-messages>\n        </div>\n      </div>\n      <div class=\"buttons form-group field-submit\">\n        <button type=\"submit\" class=\"button button-submit\" [disabled]=\"!signupForm.valid\">{{ 'signup.button' | translate }}</button>\n      </div>\n    </div>\n  </form>\n</div>\n",
                styles: ["button{width:100%}"]
            }] }
];
/** @nocollapse */
SignupTwoComponent.ctorParameters = () => [
    { type: FormBuilder },
    { type: ActivatedRoute },
    { type: ConfigInfoService },
    { type: ValidationFormService }
];
if (false) {
    /** @type {?} */
    SignupTwoComponent.prototype.sessionId;
    /** @type {?} */
    SignupTwoComponent.prototype.session;
    /** @type {?} */
    SignupTwoComponent.prototype.country;
    /** @type {?} */
    SignupTwoComponent.prototype.errorMessage;
    /** @type {?} */
    SignupTwoComponent.prototype.signupForm;
    /**
     * @type {?}
     * @private
     */
    SignupTwoComponent.prototype.fb;
    /**
     * @type {?}
     * @private
     */
    SignupTwoComponent.prototype.route;
    /**
     * @type {?}
     * @private
     */
    SignupTwoComponent.prototype.configInfoService;
    /**
     * @type {?}
     * @private
     */
    SignupTwoComponent.prototype.validationService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/components/signup-three/signup-three.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class SignupThreeComponent {
    /**
     * @param {?} fb
     * @param {?} route
     * @param {?} configInfoService
     * @param {?} validationService
     */
    constructor(fb, route, configInfoService, validationService) {
        this.fb = fb;
        this.route = route;
        this.configInfoService = configInfoService;
        this.validationService = validationService;
        this.country = this.route.snapshot.routeConfig.path.toUpperCase();
        this.signupForm = this.fb.group({
            'prospect': this.fb.group({
                'firstName': ['', [Validators.required, ValidationFormService.firstNameValidator, Validators.minLength(2), Validators.maxLength(255)]],
                'lastName': ['', [Validators.required, ValidationFormService.lastNameValidator, Validators.minLength(2), Validators.maxLength(255)]],
                'phone': ['', [Validators.required, Validators.minLength(6), Validators.maxLength(20)]],
                'email': ['', [Validators.required, Validators.email, ValidationFormService.emailValidator, Validators.minLength(4), Validators.maxLength(255)]],
                'address': this.fb.group({
                    'city': ['', [Validators.required, ValidationFormService.cityValidator, Validators.minLength(2), Validators.maxLength(255)]],
                    'street': ['', [Validators.required, Validators.minLength(2), Validators.maxLength(255)]],
                    'country': [this.country],
                    'state': ['', [Validators.required, Validators.minLength(2), Validators.maxLength(255)]]
                })
            })
        });
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.country = this.route.snapshot.routeConfig.path.toUpperCase();
        this.preFiledInfo();
    }
    /**
     * @return {?}
     */
    preFiledInfo() {
        /** @type {?} */
        const config = JSON.parse(localStorage.getItem('config'));
        if (config !== null && config !== '' && config.prospect) {
            this.signupForm.controls.prospect.patchValue({
                "firstName": this.configInfoService.getConfigInfo('prospect', 'firstName'),
                "lastName": this.configInfoService.getConfigInfo('prospect', 'lastName'),
                "phone": this.configInfoService.getConfigInfo('prospect', 'phone'),
                "email": this.configInfoService.getConfigInfo('prospect', 'email'),
                "address": {
                    "city": this.configInfoService.getConfigInfo('prospect', 'address', 'city'),
                    "street": this.configInfoService.getConfigInfo('prospect', 'address', 'street'),
                    "state": this.configInfoService.getConfigInfo('prospect', 'address', 'state')
                }
            });
        }
    }
    /**
     * @return {?}
     */
    patchSession() {
        this.errorMessage = null;
        this.sessionId = this.configInfoService.getConfigInfo('id');
        if (this.signupForm.dirty && this.signupForm.valid && this.validationService.checkHistoryEmail(this.signupForm) === true) {
            this.validationService.verifAndPatchSession(this.signupForm, this.sessionId).subscribe((/**
             * @param {?} session
             * @return {?}
             */
            session => {
                /** @type {?} */
                let redirectionUrl = this.configInfoService.getConfigInfo('campaign', 'offers', [0], 'brands', [1], 'domain');
                window.location.href = `https://${redirectionUrl}/payment/${this.sessionId}`;
            }), (/**
             * @param {?} error
             * @return {?}
             */
            error => {
                this.errorMessage = error;
            }));
        }
        else
            this.errorMessage = 'An error occurred';
    }
}
SignupThreeComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-signup-three',
                template: "<div class=\"form-signup-three-wrapper\">\n  <form [formGroup]=\"signupForm\" (ngSubmit)=\"patchSession()\" class=\"form form-signup-three\">\n    <div formGroupName=\"prospect\" class=\"prospect-wrapper\">\n      <div class=\"name-group field-group\">\n        <div class=\"first-name field form-group\">\n          <label for=\"firstName\" class=\"first-name-label label\">{{ 'signup.label.firstname' | translate }}</label>\n          <input type=\"text\" class=\"first-name-input form-control\" id=\"firstName\" placeholder=\"{{ 'signup.placeholder.firstname' | translate }}\" formControlName=\"firstName\" required>\n          <lib-control-messages [control]=\"signupForm.get(['prospect', 'firstName'])\"></lib-control-messages>\n        </div>\n        <div class=\"lastName form-group field\">\n          <label for=\"lastName\" class=\"last-name-label label\">{{ 'signup.label.lastname' | translate }}</label>\n          <input type=\"text\" class=\"last-name-input form-control\" id=\"lastName\" placeholder=\"{{ 'signup.placeholder.lastname' | translate }}\" formControlName=\"lastName\" required>\n          <lib-control-messages [control]=\"signupForm.get(['prospect', 'lastName'])\"></lib-control-messages>\n        </div>\n      </div>\n      <div formGroupName=\"address\" class=\"address-group field-group\">\n        <div class=\"address form-group field\">\n          <label for=\"street\" class=\"address-label label\">{{ 'signup.label.address' | translate }}</label>\n          <input type=\"text\" class=\"address-input form-control\" id=\"street\" placeholder=\"{{ 'signup.placeholder.address' | translate }}\" formControlName=\"street\" required specialIsAlphaNumeric>\n          <lib-control-messages [control]=\"signupForm.get(['prospect', 'address', 'street'])\"></lib-control-messages>\n        </div>\n        <div class=\"field\">\n          <div class=\"city-wrapper\">\n            <label for=\"city\" class=\"label\">{{ 'signup.label.city' | translate }}:</label>\n            <input type=\"text\" class=\"form-control\" id=\"city\" placeholder=\"{{ 'signup.placeholder.city' | translate }}\" formControlName=\"city\" specialIsAlphaNumeric required>\n            <lib-control-messages [control]=\"signupForm.get(['prospect', 'address', 'city'])\"></lib-control-messages>\n          </div>\n      </div>\n        <div class=\"state form-group field\">\n          <label for=\"state\" class=\"state-label label\">{{ 'signup.label.state' | translate }}</label>\n          <input type=\"text\" class=\"state-input form-control\" id=\"state\" placeholder=\"{{ 'signup.placeholder.state' | translate }}\" formControlName=\"state\" required specialIsAlphaNumeric>\n          <lib-control-messages [control]=\"signupForm.get(['prospect', 'address', 'state'])\"></lib-control-messages>\n        </div>\n      </div>\n      <div class=\"contact-group field-group\">\n        <div class=\"phone form-group field\">\n          <label for=\"phone\" class=\"phone-label label\">{{ 'signup.label.phone' | translate }}</label>\n          <input type=\"text\" class=\"phone-input form-control\" id=\"phone\" placeholder=\"{{ 'signup.placeholder.phone' | translate }}\" formControlName=\"phone\" required phoneNumeric>\n          <lib-control-messages [control]=\"signupForm.get(['prospect', 'phone'])\"></lib-control-messages>\n        </div>\n        <div class=\"email form-group field\">\n          <label for=\"email\" class=\"email-label label\">{{ 'signup.label.email' | translate }}</label>\n          <input type=\"text\" class=\"email-input form-control\" id=\"email\" placeholder=\"{{ 'signup.placeholder.email' | translate }}\" formControlName=\"email\" required>\n          <lib-control-messages [control]=\"signupForm.get(['prospect', 'email'])\"></lib-control-messages>\n        </div>\n      </div>\n      <div class=\"buttons form-group field-submit\">\n        <button type=\"submit\" class=\"button button-submit\" [disabled]=\"!signupForm.valid\">{{ 'signup.button' | translate }}</button>\n      </div>\n    </div>\n  </form>\n</div>\n",
                styles: ["button{width:100%}"]
            }] }
];
/** @nocollapse */
SignupThreeComponent.ctorParameters = () => [
    { type: FormBuilder },
    { type: ActivatedRoute },
    { type: ConfigInfoService },
    { type: ValidationFormService }
];
if (false) {
    /** @type {?} */
    SignupThreeComponent.prototype.sessionId;
    /** @type {?} */
    SignupThreeComponent.prototype.session;
    /** @type {?} */
    SignupThreeComponent.prototype.country;
    /** @type {?} */
    SignupThreeComponent.prototype.errorMessage;
    /** @type {?} */
    SignupThreeComponent.prototype.signupForm;
    /**
     * @type {?}
     * @private
     */
    SignupThreeComponent.prototype.fb;
    /**
     * @type {?}
     * @private
     */
    SignupThreeComponent.prototype.route;
    /**
     * @type {?}
     * @private
     */
    SignupThreeComponent.prototype.configInfoService;
    /**
     * @type {?}
     * @private
     */
    SignupThreeComponent.prototype.validationService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/components/signup-four/signup-four.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class SignupFourComponent {
    /**
     * @param {?} fb
     * @param {?} route
     * @param {?} validationService
     * @param {?} configInfoService
     */
    constructor(fb, route, validationService, configInfoService) {
        this.fb = fb;
        this.route = route;
        this.validationService = validationService;
        this.configInfoService = configInfoService;
        this.country = this.route.snapshot.routeConfig.path.toUpperCase();
        this.signupForm = this.fb.group({
            'prospect': this.fb.group({
                'firstName': ['', [Validators.required, ValidationFormService.firstNameValidator, Validators.minLength(2), Validators.maxLength(255)]],
                'lastName': ['', [Validators.required, ValidationFormService.lastNameValidator, Validators.minLength(2), Validators.maxLength(255)]],
                'phone': ['', [Validators.required, Validators.minLength(6), Validators.maxLength(20)]],
                'email': ['', [Validators.required, Validators.email, ValidationFormService.emailValidator, Validators.minLength(4), Validators.maxLength(255)]],
                'address': this.fb.group({
                    'postcode': ['', [Validators.required, Validators.minLength(2), Validators.maxLength(20)]],
                    'city': ['', [Validators.required, ValidationFormService.cityValidator, Validators.minLength(2), Validators.maxLength(255)]],
                    'street': ['', [Validators.required, Validators.minLength(2), Validators.maxLength(255)]],
                    'country': [this.country],
                    'state': ['', [Validators.required, Validators.minLength(2), Validators.maxLength(255)]]
                })
            })
        });
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.country = this.route.snapshot.routeConfig.path.toUpperCase();
        this.preFiledInfo();
    }
    /**
     * @return {?}
     */
    preFiledInfo() {
        /** @type {?} */
        const config = JSON.parse(localStorage.getItem('config'));
        if (config !== null && config !== '' && config.prospect) {
            this.signupForm.controls.prospect.patchValue({
                "firstName": this.configInfoService.getConfigInfo('prospect', 'firstName'),
                "lastName": this.configInfoService.getConfigInfo('prospect', 'lastName'),
                "phone": this.configInfoService.getConfigInfo('prospect', 'phone'),
                "email": this.configInfoService.getConfigInfo('prospect', 'email'),
                "address": {
                    "city": this.configInfoService.getConfigInfo('prospect', 'address', 'city'),
                    "postcode": this.configInfoService.getConfigInfo('prospect', 'address', 'postcode'),
                    "street": this.configInfoService.getConfigInfo('prospect', 'address', 'street'),
                    "state": this.configInfoService.getConfigInfo('prospect', 'address', 'state')
                }
            });
        }
    }
    /**
     * @return {?}
     */
    patchSession() {
        this.errorMessage = null;
        this.sessionId = this.configInfoService.getConfigInfo('id');
        if (this.signupForm.dirty && this.signupForm.valid && this.validationService.checkHistoryEmail(this.signupForm) === true) {
            this.validationService.verifAndPatchSession(this.signupForm, this.sessionId).subscribe((/**
             * @param {?} session
             * @return {?}
             */
            session => {
                /** @type {?} */
                let redirectionUrl = this.configInfoService.getConfigInfo('campaign', 'offers', [0], 'brands', [1], 'domain');
                window.location.href = `https://${redirectionUrl}/payment/${this.sessionId}`;
            }), (/**
             * @param {?} error
             * @return {?}
             */
            error => {
                this.errorMessage = error;
            }));
        }
        else
            this.errorMessage = 'An error occurred';
    }
}
SignupFourComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-signup-four',
                template: "<div class=\"signup-wrapper signup-four\">\n  <form [formGroup]=\"signupForm\" (ngSubmit)=\"patchSession()\" class=\"signup-form\">\n    <div formGroupName=\"prospect\" class=\"prospect-wrapper\">\n      <div class=\"signup-four-wrapper\">\n        <div class=\"field\">\n          <div class=\"firstName-wrapper\">\n            <label for=\"firstName\" class=\"label\">{{ 'signup.label.firstname' | translate }}:</label>\n            <input type=\"text\" class=\"form-control\" id=\"firstName\" placeholder=\"{{ 'signup.placeholder.firstname' | translate }}\" formControlName=\"firstName\" required>\n            <lib-control-messages [control]=\"signupForm.get(['prospect', 'firstName'])\"></lib-control-messages>\n          </div>\n        </div>\n        <div class=\"field\">\n          <div class=\"lastName-wrapper\">\n            <label for=\"lastName\" class=\"label\">{{ 'signup.label.lastname' | translate }}:</label>\n            <input type=\"text\" class=\"form-control\" id=\"lastName\" placeholder=\"{{ 'signup.placeholder.lastname' | translate }}\" formControlName=\"lastName\" required>\n            <lib-control-messages [control]=\"signupForm.get(['prospect', 'lastName'])\"></lib-control-messages>\n          </div>\n        </div>\n        <div formGroupName=\"address\" class=\"address-wrapper\">\n          <div class=\"field\">\n            <div class=\"address-wrapper\">\n              <label for=\"street\" class=\"label\">{{ 'signup.label.address' | translate }}:</label>\n              <input type=\"text\" class=\"form-control\" id=\"street\" placeholder=\"{{ 'signup.placeholder.address' | translate }}\" formControlName=\"street\" required specialIsAlphaNumeric>\n              <lib-control-messages [control]=\"signupForm.get(['prospect', 'address', 'street'])\"></lib-control-messages>\n            </div>\n          </div>\n          <div class=\"field\">\n            <div class=\"postcode-wrapper\">\n              <label for=\"postcode\" class=\"label\">{{ 'signup.label.postcode' | translate }}:</label>\n              <input type=\"text\" class=\"form-control\" id=\"postcode\" placeholder=\"{{ 'signup.placeholder.postcode' | translate }}\" formControlName=\"postcode\" required specialIsAlphaNumeric>\n              <lib-control-messages [control]=\"signupForm.get(['prospect', 'address', 'postcode'])\"></lib-control-messages>\n            </div>\n          </div>\n          <div class=\"field\">\n            <div class=\"city-wrapper\">\n              <label for=\"city\" class=\"label\">{{ 'signup.label.city' | translate }}:</label>\n              <input type=\"text\" class=\"form-control\" id=\"city\" placeholder=\"{{ 'signup.placeholder.city' | translate }}\" formControlName=\"city\" required specialIsAlphaNumeric>\n              <lib-control-messages [control]=\"signupForm.get(['prospect', 'address', 'city'])\"></lib-control-messages>\n            </div>\n          </div>\n          <div class=\"field\">\n            <div class=\"state-wrapper\">\n              <label for=\"state\" class=\"label\">{{ 'signup.label.state' | translate }}:</label>\n              <input type=\"text\" class=\"form-control\" id=\"state\" placeholder=\"{{ 'signup.placeholder.state' | translate }}\" formControlName=\"state\" required specialIsAlphaNumeric>\n              <lib-control-messages [control]=\"signupForm.get(['prospect', 'address', 'state'])\"></lib-control-messages>\n            </div>\n          </div>\n        </div>\n        <div class=\"field\">\n          <div class=\"phone-wrapper\">\n            <label for=\"phone\" class=\"label\">{{ 'signup.label.phone' | translate }}:</label>\n            <input type=\"text\" class=\"form-control\" id=\"phone\" placeholder=\"{{ 'signup.placeholder.phone' | translate }}\" formControlName=\"phone\" required phoneNumeric>\n            <lib-control-messages [control]=\"signupForm.get(['prospect', 'phone'])\"></lib-control-messages>\n          </div>\n        </div>\n        <div class=\"field\">\n          <div class=\"email-wrapper\">\n            <label for=\"email\" class=\"label\">{{ 'signup.label.email' | translate }}:</label>\n            <input type=\"text\" class=\"form-control\" id=\"email\" placeholder=\"{{ 'signup.placeholder.email' | translate }}\" formControlName=\"email\" required>\n            <lib-control-messages [control]=\"signupForm.get(['prospect', 'email'])\"></lib-control-messages>\n          </div>\n        </div>\n        <div class=\"error-message\">\n          <p>{{errorMessage}}</p>\n        </div>\n        <div class=\"field\">\n          <div class=\"button-wrapper\">\n            <button type=\"submit\" class=\"btn btn-success\" [disabled]=\"!signupForm.valid\">{{ 'signup.button' | translate }}</button>\n          </div>\n        </div>\n      </div>\n    </div>\n  </form>\n</div>\n",
                styles: ["button{width:100%}"]
            }] }
];
/** @nocollapse */
SignupFourComponent.ctorParameters = () => [
    { type: FormBuilder },
    { type: ActivatedRoute },
    { type: ValidationFormService },
    { type: ConfigInfoService }
];
if (false) {
    /** @type {?} */
    SignupFourComponent.prototype.sessionId;
    /** @type {?} */
    SignupFourComponent.prototype.session;
    /** @type {?} */
    SignupFourComponent.prototype.country;
    /** @type {?} */
    SignupFourComponent.prototype.errorMessage;
    /** @type {?} */
    SignupFourComponent.prototype.signupForm;
    /**
     * @type {?}
     * @private
     */
    SignupFourComponent.prototype.fb;
    /**
     * @type {?}
     * @private
     */
    SignupFourComponent.prototype.route;
    /**
     * @type {?}
     * @private
     */
    SignupFourComponent.prototype.validationService;
    /**
     * @type {?}
     * @private
     */
    SignupFourComponent.prototype.configInfoService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/components/terms/terms.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class TermsComponent {
    /**
     * @param {?} configInfoService
     */
    constructor(configInfoService) {
        this.configInfoService = configInfoService;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        // this.getInitialPeriod();
        this.getCurrency();
        this.getInitialPrice();
        // this.getReBillPeriod();
        this.getReBillPrice();
        this.getCurrentYear();
    }
    /**
     * @return {?}
     */
    getReBillPrice() {
        this.reBillPrice = this.configInfoService.getConfigInfo('campaign', 'offers', [0], 'products', [0], 'installments', [1], 'price');
    }
    /**
     * @return {?}
     */
    getInitialPeriod() {
        this.initialPeriod = `${this.configInfoService.getConfigInfo('campaign', 'offers', [0], 'products', [0], 'installments', [0], 'cycle', 'count')} 
    ${this.initialPeriod += this.configInfoService.getConfigInfo('campaign', 'offers', [0], 'products', [0], 'installments', [0], 'cycle', 'type')}`;
    }
    /**
     * @return {?}
     */
    getCurrency() {
        this.currency = this.configInfoService.getConfigInfo('campaign', 'currency');
    }
    /**
     * @return {?}
     */
    getReBillPeriod() {
        this.reBillPeriod = `${this.configInfoService.getConfigInfo('campaign', 'offers', [0], 'products', [0], 'installments', [1], 'cycle', 'count')} 
    ${this.reBillPeriod += this.configInfoService.getConfigInfo('campaign', 'offers', [0], 'products', [0], 'installments', [1], 'cycle', 'type')}`;
    }
    /**
     * @return {?}
     */
    getInitialPrice() {
        this.initialPrice = this.configInfoService.getConfigInfo('campaign', 'offers', [0], 'products', [0], 'installments', [0], 'price');
    }
    /**
     * @return {?}
     */
    getCurrentYear() {
        this.currentYear = this.configInfoService.getCurrentYear();
    }
}
TermsComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-terms',
                template: "<p class=\"terms\">{{ 'terms.text' | translate:{'initialPeriod':initialPeriod, 'currency': currency, 'initialPrice': initialPrice, 'reBillPeriod': reBillPeriod, 'reBillPrice': reBillPrice, 'currentYear': currentYear} }}</p>\n",
                styles: [""]
            }] }
];
/** @nocollapse */
TermsComponent.ctorParameters = () => [
    { type: ConfigInfoService }
];
if (false) {
    /** @type {?} */
    TermsComponent.prototype.initialPeriod;
    /** @type {?} */
    TermsComponent.prototype.currency;
    /** @type {?} */
    TermsComponent.prototype.initialPrice;
    /** @type {?} */
    TermsComponent.prototype.reBillPeriod;
    /** @type {?} */
    TermsComponent.prototype.reBillPrice;
    /** @type {?} */
    TermsComponent.prototype.currentYear;
    /**
     * @type {?}
     * @private
     */
    TermsComponent.prototype.configInfoService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/components/control-message/control-message.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ControlMessagesComponent {
    constructor() { }
    /**
     * @return {?}
     */
    get errorMessage() {
        for (let propertyName in this.control.errors) {
            if (this.control.errors.hasOwnProperty(propertyName) &&
                this.control.touched) {
                return propertyName;
            }
        }
        return null;
    }
}
ControlMessagesComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-control-messages',
                template: `
    <div *ngIf="errorMessage !== null">{{'signup.errors.'+errorMessage | translate:{'minlength' : this.control.errors[errorMessage].requiredLength} }}</div>
  `
            }] }
];
/** @nocollapse */
ControlMessagesComponent.ctorParameters = () => [];
ControlMessagesComponent.propDecorators = {
    control: [{ type: Input }]
};
if (false) {
    /** @type {?} */
    ControlMessagesComponent.prototype.control;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/directives/validation/numeric.directive.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NumericDirective {
    /**
     * @param {?} elRef
     * @param {?} renderer
     * @param {?} control
     */
    constructor(elRef, renderer, control) {
        this.elRef = elRef;
        this.renderer = renderer;
        this.control = control;
        this.regexStr = '^[0-9]+(?:[\w -]*[0-9]+)*$';
    }
    /**
     * @param {?} event
     * @return {?}
     */
    onKeyPress(event) {
        return new RegExp(this.regexStr).test(event.key);
    }
    /**
     * @param {?} event
     * @return {?}
     */
    onPaste(event) {
        event.preventDefault();
        this.control.control
            .setValue(event.clipboardData
            .getData('text/plain')
            .replace(/\D/g, ''));
    }
}
NumericDirective.decorators = [
    { type: Directive, args: [{
                selector: '[NumericCharacters]'
            },] }
];
/** @nocollapse */
NumericDirective.ctorParameters = () => [
    { type: ElementRef },
    { type: Renderer2 },
    { type: NgControl }
];
NumericDirective.propDecorators = {
    onKeyPress: [{ type: HostListener, args: ['keypress', ['$event'],] }],
    onPaste: [{ type: HostListener, args: ['paste', ['$event'],] }]
};
if (false) {
    /** @type {?} */
    NumericDirective.prototype.regexStr;
    /**
     * @type {?}
     * @private
     */
    NumericDirective.prototype.elRef;
    /**
     * @type {?}
     * @private
     */
    NumericDirective.prototype.renderer;
    /**
     * @type {?}
     * @private
     */
    NumericDirective.prototype.control;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/directives/validation/phone.directive.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class PhoneDirective {
    /**
     * @param {?} elRef
     * @param {?} renderer
     * @param {?} control
     */
    constructor(elRef, renderer, control) {
        this.elRef = elRef;
        this.renderer = renderer;
        this.control = control;
        this.regexStr = '^[+0-9]+(?:[\w -]*[0-9]+)*$';
    }
    /**
     * @param {?} event
     * @return {?}
     */
    onKeyPress(event) {
        return new RegExp(this.regexStr).test(event.key);
    }
    /**
     * @param {?} event
     * @return {?}
     */
    onPaste(event) {
        event.preventDefault();
        this.control.control
            .setValue(event.clipboardData
            .getData('text/plain')
            .replace(/[^+0-9]/g, ''));
    }
}
PhoneDirective.decorators = [
    { type: Directive, args: [{
                selector: '[phoneNumeric]'
            },] }
];
/** @nocollapse */
PhoneDirective.ctorParameters = () => [
    { type: ElementRef },
    { type: Renderer2 },
    { type: NgControl }
];
PhoneDirective.propDecorators = {
    onKeyPress: [{ type: HostListener, args: ['keypress', ['$event'],] }],
    onPaste: [{ type: HostListener, args: ['paste', ['$event'],] }]
};
if (false) {
    /** @type {?} */
    PhoneDirective.prototype.regexStr;
    /**
     * @type {?}
     * @private
     */
    PhoneDirective.prototype.elRef;
    /**
     * @type {?}
     * @private
     */
    PhoneDirective.prototype.renderer;
    /**
     * @type {?}
     * @private
     */
    PhoneDirective.prototype.control;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/directives/validation/alpha-numeric.directive.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class SpecialCharacterDirective {
    /**
     * @param {?} elRef
     * @param {?} renderer
     * @param {?} control
     */
    constructor(elRef, renderer, control) {
        this.elRef = elRef;
        this.renderer = renderer;
        this.control = control;
        this.regexStr = '^[a-zA-Z0-9_ ]+(?:[\w -]*[a-zA-Z0-9]+)*$';
    }
    /**
     * @param {?} event
     * @return {?}
     */
    onKeyPress(event) {
        return new RegExp(this.regexStr).test(event.key);
    }
    /**
     * @param {?} event
     * @return {?}
     */
    onPaste(event) {
        event.preventDefault();
        this.control.control
            .setValue(event.clipboardData
            .getData('text/plain')
            .replace(/[^A-Za-z0-9 ]/g, ' ')
            .replace(/\s/g, ' '));
    }
}
SpecialCharacterDirective.decorators = [
    { type: Directive, args: [{
                selector: '[specialIsAlphaNumeric]'
            },] }
];
/** @nocollapse */
SpecialCharacterDirective.ctorParameters = () => [
    { type: ElementRef },
    { type: Renderer2 },
    { type: NgControl }
];
SpecialCharacterDirective.propDecorators = {
    onKeyPress: [{ type: HostListener, args: ['keypress', ['$event'],] }],
    onPaste: [{ type: HostListener, args: ['paste', ['$event'],] }]
};
if (false) {
    /** @type {?} */
    SpecialCharacterDirective.prototype.regexStr;
    /**
     * @type {?}
     * @private
     */
    SpecialCharacterDirective.prototype.elRef;
    /**
     * @type {?}
     * @private
     */
    SpecialCharacterDirective.prototype.renderer;
    /**
     * @type {?}
     * @private
     */
    SpecialCharacterDirective.prototype.control;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/components/countdown/countdown.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class CountdownComponent {
    constructor() {
        this.setHours = 0;
        this.setMinutes = 0;
        this.finishedMessage = 'Offer ended';
        this.hideLabels = true;
        this.counterFinished = false;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.counter();
    }
    /**
     * @return {?}
     */
    counter() {
        /** @type {?} */
        const date = new Date;
        /** @type {?} */
        const countHours = Math.floor(this.setHours * (1000 * 60 * 60));
        /** @type {?} */
        const countMinutes = Math.floor(this.setMinutes * (1000 * 60));
        /** @type {?} */
        const endTime = date.setTime(date.getTime() + countHours + countMinutes);
        /** @type {?} */
        const x = setInterval((/**
         * @return {?}
         */
        () => {
            /** @type {?} */
            const n = new Date().getTime();
            this.count = endTime - n;
            this.hours = Math.floor((this.count / (1000 * 60 * 60)) % 24);
            this.minutes = Math.floor((this.count / 1000 / 60) % 60);
            this.seconds = Math.floor((this.count / 1000) % 60);
            if (this.count <= 0) {
                clearInterval(x);
                this.counterFinished = true;
            }
        }), 1000);
    }
}
CountdownComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-countdown',
                template: "<div *ngIf=\"counterFinished; else notFinished\" class=\"countdown\">\n    <div class=\"countdown-inner\">\n        <div class=\"countdown-message\">{{finishedMessage}}</div>\n    </div>\n</div>\n<ng-template #notFinished>\n<div class=\"countdown\">\n    <div class=\"countdown-inner\">        \n        <div *ngIf=\"setHours\" class=\"countdown-count countdown-count-hours\">\n            <div *ngIf=\"hideLabels\" class=\"countdown-count-label\">hours</div>\n            <div class=\"countdown-count-value\">{{hours | number : '2.0'}}</div>\n        </div>\n        <div class=\"countdown-count countdown-count-minutes\">\n            <div *ngIf=\"hideLabels\" class=\"countdown-count-label\">minutes</div>\n            <div class=\"countdown-count-value\">{{minutes | number : '2.0'}}</div>\n        </div>\n        <div class=\"countdown-count countdown-count-seconds\">\n            <div *ngIf=\"hideLabels\" class=\"countdown-count-label\">seconds</div>\n            <div class=\"countdown-count-value\">{{seconds | number : '2.0'}}</div>\n        </div>\n    </div>    \n</div>\n</ng-template>",
                styles: [""]
            }] }
];
/** @nocollapse */
CountdownComponent.ctorParameters = () => [];
CountdownComponent.propDecorators = {
    setHours: [{ type: Input }],
    setMinutes: [{ type: Input }],
    finishedMessage: [{ type: Input }],
    hideLabels: [{ type: Input }]
};
if (false) {
    /** @type {?} */
    CountdownComponent.prototype.setHours;
    /** @type {?} */
    CountdownComponent.prototype.setMinutes;
    /** @type {?} */
    CountdownComponent.prototype.finishedMessage;
    /** @type {?} */
    CountdownComponent.prototype.hideLabels;
    /** @type {?} */
    CountdownComponent.prototype.counterFinished;
    /** @type {?} */
    CountdownComponent.prototype.hours;
    /** @type {?} */
    CountdownComponent.prototype.minutes;
    /** @type {?} */
    CountdownComponent.prototype.seconds;
    /** @type {?} */
    CountdownComponent.prototype.count;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/campaigns-core.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
const ɵ0 = environment;
class CampaignsCoreModule {
    /**
     * @param {?} utilsService
     */
    constructor(utilsService) {
        this.utilsService = utilsService;
        this.utilsService.setConfigSession();
        this.utilsService.setDefaultTranslation();
        this.utilsService.setRoutClassOnBody();
        this.utilsService.setCakeParams();
    }
}
CampaignsCoreModule.decorators = [
    { type: NgModule, args: [{
                declarations: [CampaignsCoreComponent, SignupComponent, InitialPeriodComponent, InitialPriceComponent, ReBillPriceComponent, ReBillPeriodComponent, CurrencyComponent, CurrentYearComponent, ConfigInfoComponent, SignupTwoComponent, SignupThreeComponent, SignupFourComponent, TermsComponent, ControlMessagesComponent, SpecialCharacterDirective, NumericDirective, PhoneDirective, SpecialCharacterDirective, CountdownComponent],
                imports: [
                    CommonModule,
                    HttpClientModule,
                    TranslateModule.forRoot({
                        loader: {
                            provide: TranslateLoader,
                            useFactory: HttpLoaderFactory,
                            deps: [HttpClient]
                        }
                    }),
                    FormsModule,
                    ReactiveFormsModule
                ],
                exports: [CampaignsCoreComponent, SignupComponent, InitialPeriodComponent, InitialPriceComponent, ReBillPriceComponent, ReBillPeriodComponent, CurrencyComponent, CurrentYearComponent, SignupTwoComponent, SignupThreeComponent, SignupFourComponent, TermsComponent, CountdownComponent],
                providers: [
                    {
                        provide: 'CompanyInfoService', useClass: CompanyInfoService
                    },
                    {
                        provide: 'ConfigInfoComponent', useClass: ConfigInfoComponent
                    },
                    {
                        provide: 'environment', useValue: ɵ0
                    }
                ]
            },] }
];
/** @nocollapse */
CampaignsCoreModule.ctorParameters = () => [
    { type: UtilsService }
];
if (false) {
    /**
     * @type {?}
     * @private
     */
    CampaignsCoreModule.prototype.utilsService;
}
/**
 * @param {?} http
 * @return {?}
 */
function HttpLoaderFactory(http) {
    return new MultiTranslateHttpLoader(http, []);
}

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: campaigns-core.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { CampaignsCoreComponent, CampaignsCoreModule, CampaignsCoreService, CompanyInfoService, HttpLoaderFactory, SignupComponent as ɵa, ConfigInfoService as ɵb, SessionService as ɵc, UtilsService as ɵd, ValidationFormService as ɵe, InitialPeriodComponent as ɵf, InitialPriceComponent as ɵg, ReBillPriceComponent as ɵh, ReBillPeriodComponent as ɵi, CurrencyComponent as ɵj, CurrentYearComponent as ɵk, ConfigInfoComponent as ɵl, SignupTwoComponent as ɵm, SignupThreeComponent as ɵn, SignupFourComponent as ɵo, TermsComponent as ɵp, ControlMessagesComponent as ɵq, SpecialCharacterDirective as ɵr, NumericDirective as ɵs, PhoneDirective as ɵt, CountdownComponent as ɵu, environment as ɵv };
//# sourceMappingURL=campaigns-core.js.map
