import { Injectable, ɵɵdefineInjectable, Component, Inject, ɵɵinject, RendererFactory2, Input, Directive, ElementRef, Renderer2, HostListener, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { TranslateService, TranslateModule, TranslateLoader } from '@ngx-translate/core';
import { __spread } from 'tslib';
import { HttpHeaders, HttpClient, HttpClientModule } from '@angular/common/http';
import { NavigationStart, Router, ActivatedRoute } from '@angular/router';
import { Validators, FormBuilder, NgControl, FormsModule, ReactiveFormsModule } from '@angular/forms';
import { Observable } from 'rxjs';
import { sha256 } from 'js-sha256';
import { MultiTranslateHttpLoader } from 'ngx-translate-multi-http-loader';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/campaigns-core.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CampaignsCoreService = /** @class */ (function () {
    function CampaignsCoreService() {
    }
    CampaignsCoreService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    CampaignsCoreService.ctorParameters = function () { return []; };
    /** @nocollapse */ CampaignsCoreService.ngInjectableDef = ɵɵdefineInjectable({ factory: function CampaignsCoreService_Factory() { return new CampaignsCoreService(); }, token: CampaignsCoreService, providedIn: "root" });
    return CampaignsCoreService;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: lib/campaigns-core.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CampaignsCoreComponent = /** @class */ (function () {
    function CampaignsCoreComponent() {
    }
    /**
     * @return {?}
     */
    CampaignsCoreComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    CampaignsCoreComponent.decorators = [
        { type: Component, args: [{
                    selector: 'lib-campaigns-core',
                    template: "\n    <p>\n      campaigns-core works!\n    </p>\n  "
                }] }
    ];
    /** @nocollapse */
    CampaignsCoreComponent.ctorParameters = function () { return []; };
    return CampaignsCoreComponent;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: lib/services/session.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var SessionService = /** @class */ (function () {
    function SessionService(http, environment) {
        this.http = http;
        this.environment = environment;
    }
    /**
     * @return {?}
     */
    SessionService.prototype.postSession = /**
     * @return {?}
     */
    function () {
        return this.http.post(this.environment.baseApi + "/api/v1/sessions", {});
    };
    /**
     * @param {?} session
     * @param {?} sessionId
     * @return {?}
     */
    SessionService.prototype.patchSession = /**
     * @param {?} session
     * @param {?} sessionId
     * @return {?}
     */
    function (session, sessionId) {
        /** @type {?} */
        var httpHeaders = new HttpHeaders().set('Content-Type', 'application/merge-patch+json');
        return this.http.patch(this.environment.baseApi + "/api/v1/sessions/" + sessionId, session, { headers: httpHeaders });
    };
    /**
     * @param {?} sessionId
     * @return {?}
     */
    SessionService.prototype.getSession = /**
     * @param {?} sessionId
     * @return {?}
     */
    function (sessionId) {
        return this.http.get(this.environment.baseApi + "/api/v1/sessions/" + sessionId);
    };
    SessionService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    SessionService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: undefined, decorators: [{ type: Inject, args: ['environment',] }] }
    ]; };
    /** @nocollapse */ SessionService.ngInjectableDef = ɵɵdefineInjectable({ factory: function SessionService_Factory() { return new SessionService(ɵɵinject(HttpClient), ɵɵinject("environment")); }, token: SessionService, providedIn: "root" });
    return SessionService;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    SessionService.prototype.http;
    /**
     * @type {?}
     * @private
     */
    SessionService.prototype.environment;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/services/utils.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var UtilsService = /** @class */ (function () {
    function UtilsService(http, sessionService, translate, rendererFactory, router, route) {
        this.http = http;
        this.sessionService = sessionService;
        this.translate = translate;
        this.rendererFactory = rendererFactory;
        this.router = router;
        this.route = route;
    }
    /**
     * @param {?} object
     * @param {...?} args
     * @return {?}
     */
    UtilsService.prototype.getNested = /**
     * @param {?} object
     * @param {...?} args
     * @return {?}
     */
    function (object) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        return args.reduce((/**
         * @param {?} object
         * @param {?} level
         * @return {?}
         */
        function (object, level) { return object && object[level]; }), object);
    };
    /**
     * @return {?}
     */
    UtilsService.prototype.getIPAddress = /**
     * @return {?}
     */
    function () {
        return this.http.get('http://api.ipify.org/?format=json');
    };
    /**
     * @return {?}
     */
    UtilsService.prototype.getSessionId = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var config = JSON.parse(localStorage.getItem('config'));
        if (config.id) {
            return config.id;
        }
        else {
            this.sessionService.postSession().subscribe((/**
             * @param {?} session
             * @return {?}
             */
            function (session) {
                localStorage.setItem('config', JSON.stringify(session));
                return session.id;
            }));
        }
    };
    /**
     * @return {?}
     */
    UtilsService.prototype.getSession = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var config = JSON.parse(localStorage.getItem('config'));
        if (config.id) {
            return config;
        }
        else {
            this.sessionService.postSession().subscribe((/**
             * @param {?} session
             * @return {?}
             */
            function (session) {
                localStorage.setItem('config', JSON.stringify(session));
                return session;
            }));
        }
    };
    /**
     * @return {?}
     */
    UtilsService.prototype.setRoutClassOnBody = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.renderer = this.rendererFactory.createRenderer(null, null);
        this.router.events.subscribe((/**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            if (event instanceof NavigationStart) {
                /** @type {?} */
                var currentUrlSlug = event.url.slice(1);
                currentUrlSlug = currentUrlSlug.split('?');
                console.log("Mdrrr", currentUrlSlug);
                if (currentUrlSlug) {
                    _this.renderer.addClass(document.body, "geo-" + currentUrlSlug[0]);
                    _this.translate.use(currentUrlSlug[0]);
                    console.log("TESTTT", currentUrlSlug[0]);
                }
                _this.route.queryParams.subscribe((/**
                 * @param {?} params
                 * @return {?}
                 */
                function (params) {
                    if (params.lang) {
                        console.log("Mdrrr");
                        _this.renderer.addClass(document.body, "lang-" + params.lang);
                        _this.translate.use(params.lang);
                    }
                }));
            }
        }));
    };
    /**
     * @return {?}
     */
    UtilsService.prototype.setDefaultTranslation = /**
     * @return {?}
     */
    function () {
        this.translate.setDefaultLang('us');
    };
    /**
     * @return {?}
     */
    UtilsService.prototype.setCakeParams = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var cake = {
            r: null,
            o: null,
            a: null,
            sa: null
        };
        this.route.queryParams.subscribe((/**
         * @param {?} params
         * @return {?}
         */
        function (params) {
            if (params.r)
                cake.r = params.r;
            if (params.o)
                cake.o = params.o;
            if (params.a)
                cake.a = params.a;
            if (params.sa)
                cake.sa = params.sa;
            localStorage.setItem('params', JSON.stringify(cake));
        }));
    };
    /**
     * @return {?}
     */
    UtilsService.prototype.setConfigSession = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var config = localStorage.getItem('config');
        if (config !== null && config !== '') {
            config = JSON.parse(config);
        }
        if (config === null || !config['campaign']) {
            this.sessionService.postSession().subscribe((/**
             * @param {?} session
             * @return {?}
             */
            function (session) {
                localStorage.setItem('config', JSON.stringify(session));
            }));
        }
    };
    UtilsService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    UtilsService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: SessionService },
        { type: TranslateService },
        { type: RendererFactory2 },
        { type: Router },
        { type: ActivatedRoute }
    ]; };
    /** @nocollapse */ UtilsService.ngInjectableDef = ɵɵdefineInjectable({ factory: function UtilsService_Factory() { return new UtilsService(ɵɵinject(HttpClient), ɵɵinject(SessionService), ɵɵinject(TranslateService), ɵɵinject(RendererFactory2), ɵɵinject(Router), ɵɵinject(ActivatedRoute)); }, token: UtilsService, providedIn: "root" });
    return UtilsService;
}());
if (false) {
    /** @type {?} */
    UtilsService.prototype.renderer;
    /**
     * @type {?}
     * @private
     */
    UtilsService.prototype.http;
    /**
     * @type {?}
     * @private
     */
    UtilsService.prototype.sessionService;
    /**
     * @type {?}
     * @private
     */
    UtilsService.prototype.translate;
    /**
     * @type {?}
     * @private
     */
    UtilsService.prototype.rendererFactory;
    /**
     * @type {?}
     * @private
     */
    UtilsService.prototype.router;
    /**
     * @type {?}
     * @private
     */
    UtilsService.prototype.route;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/services/config-info.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ConfigInfoService = /** @class */ (function () {
    function ConfigInfoService(sessionService, utilsService) {
        this.sessionService = sessionService;
        this.utilsService = utilsService;
    }
    /**
     * @param {...?} args
     * @return {?}
     */
    ConfigInfoService.prototype.getConfigInfo = /**
     * @param {...?} args
     * @return {?}
     */
    function () {
        var _a;
        var _this = this;
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        /** @type {?} */
        var config = JSON.parse(localStorage.getItem('config'));
        if (config !== null && config !== '' && (_a = this.utilsService).getNested.apply(_a, __spread([config], args))) {
            return (this.getConfigValue(args, config));
        }
        else {
            this.sessionService.postSession().subscribe((/**
             * @param {?} session
             * @return {?}
             */
            function (session) {
                localStorage.setItem('config', JSON.stringify(session));
                return (_this.getConfigValue(args, config));
            }));
        }
    };
    /**
     * @param {?} args
     * @param {?} config
     * @return {?}
     */
    ConfigInfoService.prototype.getConfigValue = /**
     * @param {?} args
     * @param {?} config
     * @return {?}
     */
    function (args, config) {
        args.forEach((/**
         * @param {?} val
         * @return {?}
         */
        function (val) {
            config = config[val];
        }));
        return config;
    };
    /**
     * @return {?}
     */
    ConfigInfoService.prototype.getCurrentYear = /**
     * @return {?}
     */
    function () {
        return new Date().getFullYear();
    };
    ConfigInfoService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    ConfigInfoService.ctorParameters = function () { return [
        { type: SessionService },
        { type: UtilsService }
    ]; };
    /** @nocollapse */ ConfigInfoService.ngInjectableDef = ɵɵdefineInjectable({ factory: function ConfigInfoService_Factory() { return new ConfigInfoService(ɵɵinject(SessionService), ɵɵinject(UtilsService)); }, token: ConfigInfoService, providedIn: "root" });
    return ConfigInfoService;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    ConfigInfoService.prototype.sessionService;
    /**
     * @type {?}
     * @private
     */
    ConfigInfoService.prototype.utilsService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/services/validation-form.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ValidationFormService = /** @class */ (function () {
    function ValidationFormService(sessionService, utilsService) {
        this.sessionService = sessionService;
        this.utilsService = utilsService;
    }
    /**
     * @param {?} control
     * @return {?}
     */
    ValidationFormService.emailValidator = /**
     * @param {?} control
     * @return {?}
     */
    function (control) {
        // RFC 2822 compliant regex
        if (control.value.match(/[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?/)) {
            return null;
        }
        else {
            return { invalidEmailAddress: true };
        }
    };
    /**
     * @param {?} control
     * @return {?}
     */
    ValidationFormService.firstNameValidator = /**
     * @param {?} control
     * @return {?}
     */
    function (control) {
        // RFC 2822 compliant regex
        if (control.value.match(/^[a-zA-Z]+$/)) {
            return null;
        }
        else {
            return { invalidFirstName: true };
        }
    };
    /**
     * @param {?} control
     * @return {?}
     */
    ValidationFormService.lastNameValidator = /**
     * @param {?} control
     * @return {?}
     */
    function (control) {
        // RFC 2822 compliant regex
        if (control.value.match(/^[a-zA-Z]+$/)) {
            return null;
        }
        else {
            return { invalidLastName: true };
        }
    };
    /**
     * @param {?} control
     * @return {?}
     */
    ValidationFormService.cityValidator = /**
     * @param {?} control
     * @return {?}
     */
    function (control) {
        // RFC 2822 compliant regex
        if (control.value.match(/^[a-zA-Z]+$/)) {
            return null;
        }
        else {
            return { invalidCity: true };
        }
    };
    /**
     * @param {?} signupForm
     * @param {?} sessionId
     * @return {?}
     */
    ValidationFormService.prototype.verifAndPatchSession = /**
     * @param {?} signupForm
     * @param {?} sessionId
     * @return {?}
     */
    function (signupForm, sessionId) {
        var _this = this;
        return new Observable((/**
         * @param {?} observer
         * @return {?}
         */
        function (observer) {
            /** @type {?} */
            var prospect = signupForm.value;
            _this.utilsService.getIPAddress().subscribe((/**
             * @param {?} ip
             * @return {?}
             */
            function (ip) {
                prospect.prospect['ip'] = ip.ip;
                /** @type {?} */
                var cake = _this.getCakeParams();
                prospect.affiliate = cake;
                _this.sessionService.patchSession(prospect, sessionId).subscribe((/**
                 * @param {?} session
                 * @return {?}
                 */
                function (session) {
                    _this.sessionService.getSession(sessionId).subscribe((/**
                     * @param {?} session
                     * @return {?}
                     */
                    function (session) {
                        localStorage.setItem('config', JSON.stringify(session));
                        observer.next(true);
                        observer.complete();
                    }));
                }), (/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) {
                    /** @type {?} */
                    var errorMessage = JSON.parse(error.error.detail)[0].message;
                    _this.sessionService.getSession(sessionId).subscribe((/**
                     * @param {?} session
                     * @return {?}
                     */
                    function (session) {
                        localStorage.setItem('config', JSON.stringify(session));
                        observer.error(errorMessage);
                        observer.complete();
                    }));
                }));
            }));
        }));
    };
    /**
     * @return {?}
     */
    ValidationFormService.prototype.getCakeParams = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var cake = localStorage.getItem('params');
        if (cake !== null && cake !== '') {
            cake = JSON.parse(cake);
        }
        return cake;
    };
    /**
     * @param {?} signupForm
     * @return {?}
     */
    ValidationFormService.prototype.checkHistoryEmail = /**
     * @param {?} signupForm
     * @return {?}
     */
    function (signupForm) {
        /** @type {?} */
        var session = this.utilsService.getSession();
        if (this.validationEmail(session.zBEmailValidations, signupForm) === true && this.validationEmail(session.mFEmailValidations, signupForm) === true)
            return true;
        else
            return false;
    };
    /**
     * @param {?} zeroBouce
     * @param {?} signupForm
     * @return {?}
     */
    ValidationFormService.prototype.validationEmail = /**
     * @param {?} zeroBouce
     * @param {?} signupForm
     * @return {?}
     */
    function (zeroBouce, signupForm) {
        /** @type {?} */
        var valid = true;
        zeroBouce.forEach((/**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            if (sha256(signupForm.value.prospect.email) === value.hash && value.valid === false)
                valid = false;
        }));
        return valid;
    };
    ValidationFormService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    ValidationFormService.ctorParameters = function () { return [
        { type: SessionService },
        { type: UtilsService }
    ]; };
    /** @nocollapse */ ValidationFormService.ngInjectableDef = ɵɵdefineInjectable({ factory: function ValidationFormService_Factory() { return new ValidationFormService(ɵɵinject(SessionService), ɵɵinject(UtilsService)); }, token: ValidationFormService, providedIn: "root" });
    return ValidationFormService;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    ValidationFormService.prototype.sessionService;
    /**
     * @type {?}
     * @private
     */
    ValidationFormService.prototype.utilsService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/components/signup/signup.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var SignupComponent = /** @class */ (function () {
    function SignupComponent(formBuilder, route, translate, configInfoService, validationService) {
        this.formBuilder = formBuilder;
        this.route = route;
        this.translate = translate;
        this.configInfoService = configInfoService;
        this.validationService = validationService;
        this.country = this.route.snapshot.routeConfig.path.toUpperCase();
        this.signupForm = this.formBuilder.group({
            'prospect': this.formBuilder.group({
                'firstName': ['', [Validators.required, ValidationFormService.firstNameValidator, Validators.minLength(2), Validators.maxLength(255)]],
                'lastName': ['', [Validators.required, ValidationFormService.lastNameValidator, Validators.minLength(2), Validators.maxLength(255)]],
                'phone': ['', [Validators.required, Validators.minLength(6), Validators.maxLength(20)]],
                'email': ['', [Validators.required, Validators.email, ValidationFormService.emailValidator, Validators.minLength(4), Validators.maxLength(255)]],
                'address': this.formBuilder.group({
                    'postcode': ['', [Validators.required, Validators.minLength(2), Validators.maxLength(20)]],
                    'city': ['', [Validators.required, ValidationFormService.cityValidator, Validators.minLength(2), Validators.maxLength(255)]],
                    'street': ['', [Validators.required, Validators.minLength(2), Validators.maxLength(255)]],
                    'country': [this.country],
                })
            })
        });
    }
    /**
     * @return {?}
     */
    SignupComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.country = this.route.snapshot.routeConfig.path.toUpperCase();
        this.preFiledInfo();
    };
    /**
     * @return {?}
     */
    SignupComponent.prototype.preFiledInfo = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var config = JSON.parse(localStorage.getItem('config'));
        if (config !== null && config !== '' && config.prospect) {
            this.signupForm.controls.prospect.patchValue({
                "firstName": this.configInfoService.getConfigInfo('prospect', 'firstName'),
                "lastName": this.configInfoService.getConfigInfo('prospect', 'lastName'),
                "phone": this.configInfoService.getConfigInfo('prospect', 'phone'),
                "email": this.configInfoService.getConfigInfo('prospect', 'email'),
                "address": {
                    "city": this.configInfoService.getConfigInfo('prospect', 'address', 'city'),
                    "postcode": this.configInfoService.getConfigInfo('prospect', 'address', 'postcode'),
                    "street": this.configInfoService.getConfigInfo('prospect', 'address', 'street'),
                }
            });
        }
    };
    /**
     * @return {?}
     */
    SignupComponent.prototype.patchSession = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.errorMessage = null;
        this.sessionId = this.configInfoService.getConfigInfo('id');
        if (this.signupForm.dirty && this.signupForm.valid && this.validationService.checkHistoryEmail(this.signupForm) === true) {
            this.validationService.verifAndPatchSession(this.signupForm, this.sessionId).subscribe((/**
             * @param {?} session
             * @return {?}
             */
            function (session) {
                /** @type {?} */
                var redirectionUrl = _this.configInfoService.getConfigInfo('campaign', 'offers', [0], 'brands', [1], 'domain');
                window.location.href = "https://" + redirectionUrl + "/payment/" + _this.sessionId;
            }), (/**
             * @param {?} error
             * @return {?}
             */
            function (error) {
                _this.errorMessage = error;
            }));
        }
        else
            this.errorMessage = 'An error occurred';
    };
    SignupComponent.decorators = [
        { type: Component, args: [{
                    selector: 'lib-signup',
                    template: "<div class=\"form-signup-wrapper\">\n  <form [formGroup]=\"signupForm\" (ngSubmit)=\"patchSession()\" class=\"form form-signup\">\n    <div formGroupName=\"prospect\" class=\"prospect-wrapper\">\n      <div class=\"name-group field-group\">\n        <div class=\"first-name field form-group\">\n          <label for=\"firstName\" class=\"first-name-label label\">{{ 'signup.label.firstname' | translate }}</label>\n          <input type=\"text\" class=\"first-name-input form-control\" id=\"firstName\" placeholder=\"{{ 'signup.placeholder.firstname' | translate }}\" formControlName=\"firstName\" required>\n          <lib-control-messages [control]=\"signupForm.get(['prospect', 'firstName'])\"></lib-control-messages>\n        </div>\n        <div class=\"lastName form-group field\">\n          <label for=\"lastName\" class=\"last-name-label label\">{{ 'signup.label.lastname' | translate }}</label>\n          <input type=\"text\" class=\"last-name-input form-control\" id=\"lastName\" placeholder=\"{{ 'signup.placeholder.lastname' | translate }}\" formControlName=\"lastName\" required>\n          <lib-control-messages [control]=\"signupForm.get(['prospect', 'lastName'])\"></lib-control-messages>\n        </div>\n      </div>\n      <div formGroupName=\"address\" class=\"address-group field-group\">\n        <div class=\"address form-group field\">\n          <label for=\"street\" class=\"address-label label\">{{ 'signup.label.address' | translate }}</label>\n          <input type=\"text\" class=\"address-input form-control\" id=\"street\" placeholder=\"Address\" formControlName=\"street\" required specialIsAlphaNumeric>\n          <lib-control-messages [control]=\"signupForm.get(['prospect', 'address', 'street'])\"></lib-control-messages>\n        </div>\n        <div class=\"postcode form-group field\">\n          <label for=\"postcode\" class=\"postcode-label label\">{{ 'signup.label.postcode' | translate }}</label>\n          <input type=\"text\" class=\"postcode-input form-control\" id=\"postcode\" placeholder=\"{{ 'signup.placeholder.postcode' | translate }}\" formControlName=\"postcode\" required specialIsAlphaNumeric>\n          <lib-control-messages [control]=\"signupForm.get(['prospect', 'address', 'postcode'])\"></lib-control-messages>\n        </div>\n        <div class=\"city form-group field\">\n          <label for=\"city\" class=\"city-label label\">{{ 'signup.label.city' | translate }}</label>\n          <input type=\"text\" class=\"city-input form-control\" id=\"city\" placeholder=\"{{ 'signup.placeholder.city' | translate }}\" formControlName=\"city\" required specialIsAlphaNumeric>\n          <lib-control-messages [control]=\"signupForm.get(['prospect', 'address', 'city'])\"></lib-control-messages>\n        </div>\n      </div>\n      <div class=\"contact-group field-group\">\n        <div class=\"phone form-group field\">\n          <label for=\"phone\" class=\"phone-label label\">{{ 'signup.label.phone' | translate }}</label>\n          <input type=\"text\" class=\"phone-input form-control\" id=\"phone\" placeholder=\"{{ 'signup.placeholder.phone' | translate }}\" formControlName=\"phone\" required phoneNumeric>\n          <lib-control-messages [control]=\"signupForm.get(['prospect', 'phone'])\"></lib-control-messages>\n        </div>\n        <div class=\"email form-group field\">\n          <label for=\"email\" class=\"email-label label\">{{ 'signup.label.email' | translate }}</label>\n          <input type=\"text\" class=\"email-input form-control\" id=\"email\" placeholder=\"{{ 'signup.placeholder.email' | translate }}\" formControlName=\"email\" required>\n          <lib-control-messages [control]=\"signupForm.get(['prospect', 'email'])\"></lib-control-messages>\n        </div>\n      </div>\n      <div class=\"buttons form-group field-submit\">\n        <button type=\"submit\" class=\"button button-submit\" [disabled]=\"!signupForm.valid\">{{ 'signup.button' | translate }}</button>\n      </div>\n    </div>\n  </form>\n</div>\n",
                    styles: ["button{width:100%}"]
                }] }
    ];
    /** @nocollapse */
    SignupComponent.ctorParameters = function () { return [
        { type: FormBuilder },
        { type: ActivatedRoute },
        { type: TranslateService },
        { type: ConfigInfoService },
        { type: ValidationFormService }
    ]; };
    return SignupComponent;
}());
if (false) {
    /** @type {?} */
    SignupComponent.prototype.sessionId;
    /** @type {?} */
    SignupComponent.prototype.session;
    /** @type {?} */
    SignupComponent.prototype.country;
    /** @type {?} */
    SignupComponent.prototype.errorMessage;
    /** @type {?} */
    SignupComponent.prototype.signupForm;
    /**
     * @type {?}
     * @private
     */
    SignupComponent.prototype.formBuilder;
    /**
     * @type {?}
     * @private
     */
    SignupComponent.prototype.route;
    /**
     * @type {?}
     * @private
     */
    SignupComponent.prototype.translate;
    /**
     * @type {?}
     * @private
     */
    SignupComponent.prototype.configInfoService;
    /**
     * @type {?}
     * @private
     */
    SignupComponent.prototype.validationService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/services/company-info.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CompanyInfoService = /** @class */ (function () {
    function CompanyInfoService() {
    }
    /**
     * @return {?}
     */
    CompanyInfoService.prototype.getYear = /**
     * @return {?}
     */
    function () {
        return "2020";
    };
    /**
     * @return {?}
     */
    CompanyInfoService.prototype.getDomain = /**
     * @return {?}
     */
    function () {
        return "domain";
    };
    /**
     * @return {?}
     */
    CompanyInfoService.prototype.getCity = /**
     * @return {?}
     */
    function () {
        return "Dubai";
    };
    /**
     * @return {?}
     */
    CompanyInfoService.prototype.getCountry = /**
     * @return {?}
     */
    function () {
        return "UAE";
    };
    /**
     * @return {?}
     */
    CompanyInfoService.prototype.getState = /**
     * @return {?}
     */
    function () {
        return "JVC";
    };
    /**
     * @return {?}
     */
    CompanyInfoService.prototype.getTags = /**
     * @return {?}
     */
    function () {
        return "bla bla bla";
    };
    CompanyInfoService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    CompanyInfoService.ctorParameters = function () { return []; };
    /** @nocollapse */ CompanyInfoService.ngInjectableDef = ɵɵdefineInjectable({ factory: function CompanyInfoService_Factory() { return new CompanyInfoService(); }, token: CompanyInfoService, providedIn: "root" });
    return CompanyInfoService;
}());
if (false) {
    /**
     * @type {?}
     * @protected
     */
    CompanyInfoService.prototype.year;
    /**
     * @type {?}
     * @protected
     */
    CompanyInfoService.prototype.domain;
    /**
     * @type {?}
     * @protected
     */
    CompanyInfoService.prototype.city;
    /**
     * @type {?}
     * @protected
     */
    CompanyInfoService.prototype.country;
    /**
     * @type {?}
     * @protected
     */
    CompanyInfoService.prototype.state;
    /**
     * @type {?}
     * @protected
     */
    CompanyInfoService.prototype.tags;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/environments/environment.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// This file can be replaced during build by using the `fileReplacements` array.
// `ng build --prod` replaces `environment.ts` with `environment.prod.ts`.
// The list of file replacements can be found in `angular.json`.
/** @type {?} */
var environment = {
    production: false,
    baseApi: 'http://landing-staging.thelmit.com'
};

/**
 * @fileoverview added by tsickle
 * Generated from: lib/components/config-info/initial-period/initial-period.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var InitialPeriodComponent = /** @class */ (function () {
    function InitialPeriodComponent(sessionService, utilsService) {
        this.sessionService = sessionService;
        this.utilsService = utilsService;
    }
    /**
     * @return {?}
     */
    InitialPeriodComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.getInitialPeriod();
    };
    /**
     * @return {?}
     */
    InitialPeriodComponent.prototype.getInitialPeriod = /**
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var config = JSON.parse(localStorage.getItem('config'));
        if (this.utilsService.getNested(config, 'campaign', 'offers', [0], 'products', [0], 'installments', [0], 'cycle', 'count') &&
            this.utilsService.getNested(config, 'campaign', 'offers', [0], 'products', [0], 'installments', [0], 'cycle', 'type')) {
            this.initialPeriod = config.campaign.offers[0].products[0].installments[0].cycle.count + " " + config.campaign.offers[0].products[0].installments[0].cycle.type;
        }
        else {
            this.sessionService.postSession().subscribe((/**
             * @param {?} session
             * @return {?}
             */
            function (session) {
                localStorage.setItem('config', JSON.stringify(session));
                _this.initialPeriod = session.campaign.offers[0].products[0].installments[0].cycle.count + " " + session.campaign.offers[0].products[0].installments[0].cycle.type;
            }));
        }
    };
    InitialPeriodComponent.decorators = [
        { type: Component, args: [{
                    selector: 'lib-initial-period',
                    template: '{{initialPeriod}}'
                }] }
    ];
    /** @nocollapse */
    InitialPeriodComponent.ctorParameters = function () { return [
        { type: SessionService },
        { type: UtilsService }
    ]; };
    return InitialPeriodComponent;
}());
if (false) {
    /** @type {?} */
    InitialPeriodComponent.prototype.initialPeriod;
    /**
     * @type {?}
     * @private
     */
    InitialPeriodComponent.prototype.sessionService;
    /**
     * @type {?}
     * @private
     */
    InitialPeriodComponent.prototype.utilsService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/components/config-info/initial-price/initial-price.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var InitialPriceComponent = /** @class */ (function () {
    function InitialPriceComponent(sessionService, utilsService) {
        this.sessionService = sessionService;
        this.utilsService = utilsService;
    }
    /**
     * @return {?}
     */
    InitialPriceComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.getInitialPrice();
    };
    /**
     * @return {?}
     */
    InitialPriceComponent.prototype.getInitialPrice = /**
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var config = JSON.parse(localStorage.getItem('config'));
        if (this.utilsService.getNested(config, 'campaign', 'offers', [0], 'products', [0], 'installments', [0], 'price')) {
            this.initialPrice = config.campaign.offers[0].products[0].installments[0].price;
        }
        else {
            this.sessionService.postSession().subscribe((/**
             * @param {?} session
             * @return {?}
             */
            function (session) {
                localStorage.setItem('config', JSON.stringify(session));
                _this.initialPrice = session.campaign.offers[0].products[0].installments[0].price;
            }));
        }
    };
    InitialPriceComponent.decorators = [
        { type: Component, args: [{
                    selector: 'lib-initial-price',
                    template: '{{initialPrice}}'
                }] }
    ];
    /** @nocollapse */
    InitialPriceComponent.ctorParameters = function () { return [
        { type: SessionService },
        { type: UtilsService }
    ]; };
    return InitialPriceComponent;
}());
if (false) {
    /** @type {?} */
    InitialPriceComponent.prototype.initialPrice;
    /**
     * @type {?}
     * @private
     */
    InitialPriceComponent.prototype.sessionService;
    /**
     * @type {?}
     * @private
     */
    InitialPriceComponent.prototype.utilsService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/components/config-info/re-bill-price/re-bill-price.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ReBillPriceComponent = /** @class */ (function () {
    function ReBillPriceComponent(sessionService, utilsService) {
        this.sessionService = sessionService;
        this.utilsService = utilsService;
    }
    /**
     * @return {?}
     */
    ReBillPriceComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.getReBillPrice();
    };
    /**
     * @return {?}
     */
    ReBillPriceComponent.prototype.getReBillPrice = /**
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var config = JSON.parse(localStorage.getItem('config'));
        if (this.utilsService.getNested(config, 'campaign', 'offers', [0], 'products', [0], 'installments', [1], 'price')) {
            this.reBillPrice = config.campaign.offers[0].products[0].installments[1].price;
        }
        else {
            this.sessionService.postSession().subscribe((/**
             * @param {?} session
             * @return {?}
             */
            function (session) {
                localStorage.setItem('config', JSON.stringify(session));
                _this.reBillPrice = session.campaign.offers[0].products[0].installments[1].price;
            }));
        }
    };
    ReBillPriceComponent.decorators = [
        { type: Component, args: [{
                    selector: 'lib-re-bill-price',
                    template: '{{reBillPrice}}'
                }] }
    ];
    /** @nocollapse */
    ReBillPriceComponent.ctorParameters = function () { return [
        { type: SessionService },
        { type: UtilsService }
    ]; };
    return ReBillPriceComponent;
}());
if (false) {
    /** @type {?} */
    ReBillPriceComponent.prototype.reBillPrice;
    /**
     * @type {?}
     * @private
     */
    ReBillPriceComponent.prototype.sessionService;
    /**
     * @type {?}
     * @private
     */
    ReBillPriceComponent.prototype.utilsService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/components/config-info/re-bill-period/re-bill-period.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ReBillPeriodComponent = /** @class */ (function () {
    function ReBillPeriodComponent(sessionService, utilsService) {
        this.sessionService = sessionService;
        this.utilsService = utilsService;
    }
    /**
     * @return {?}
     */
    ReBillPeriodComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.getReBillPeriod();
    };
    /**
     * @return {?}
     */
    ReBillPeriodComponent.prototype.getReBillPeriod = /**
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var config = JSON.parse(localStorage.getItem('config'));
        if (this.utilsService.getNested(config, 'campaign', 'offers', [0], 'products', [0], 'installments', [1], 'cycle', 'count') &&
            this.utilsService.getNested(config, 'campaign', 'offers', [0], 'products', [0], 'installments', [1], 'cycle', 'type')) {
            this.reBillPeriod = config.campaign.offers[0].products[0].installments[1].cycle.count + " " + config.campaign.offers[0].products[0].installments[1].cycle.type;
        }
        else {
            this.sessionService.postSession().subscribe((/**
             * @param {?} session
             * @return {?}
             */
            function (session) {
                localStorage.setItem('config', JSON.stringify(session));
                _this.reBillPeriod = session.campaign.offers[0].products[0].installments[1].cycle.count + " " + session.campaign.offers[0].products[0].installments[1].cycle.type;
            }));
        }
    };
    ReBillPeriodComponent.decorators = [
        { type: Component, args: [{
                    selector: 'lib-re-bill-period',
                    template: '{{reBillPeriod}}'
                }] }
    ];
    /** @nocollapse */
    ReBillPeriodComponent.ctorParameters = function () { return [
        { type: SessionService },
        { type: UtilsService }
    ]; };
    return ReBillPeriodComponent;
}());
if (false) {
    /** @type {?} */
    ReBillPeriodComponent.prototype.reBillPeriod;
    /**
     * @type {?}
     * @private
     */
    ReBillPeriodComponent.prototype.sessionService;
    /**
     * @type {?}
     * @private
     */
    ReBillPeriodComponent.prototype.utilsService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/components/config-info/currency/currency.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CurrencyComponent = /** @class */ (function () {
    function CurrencyComponent(sessionService, utilsService) {
        this.sessionService = sessionService;
        this.utilsService = utilsService;
    }
    /**
     * @return {?}
     */
    CurrencyComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.getCurrency();
    };
    /**
     * @return {?}
     */
    CurrencyComponent.prototype.getCurrency = /**
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var config = JSON.parse(localStorage.getItem('config'));
        if (this.utilsService.getNested(config, 'campaign', 'currency')) {
            this.currency = config.campaign.currency;
        }
        else {
            this.sessionService.postSession().subscribe((/**
             * @param {?} session
             * @return {?}
             */
            function (session) {
                localStorage.setItem('config', JSON.stringify(session));
                _this.currency = session.campaign.currency;
            }));
        }
    };
    CurrencyComponent.decorators = [
        { type: Component, args: [{
                    selector: 'lib-currency',
                    template: '{{currency}}'
                }] }
    ];
    /** @nocollapse */
    CurrencyComponent.ctorParameters = function () { return [
        { type: SessionService },
        { type: UtilsService }
    ]; };
    return CurrencyComponent;
}());
if (false) {
    /** @type {?} */
    CurrencyComponent.prototype.currency;
    /**
     * @type {?}
     * @private
     */
    CurrencyComponent.prototype.sessionService;
    /**
     * @type {?}
     * @private
     */
    CurrencyComponent.prototype.utilsService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/components/config-info/current-year/current-year.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CurrentYearComponent = /** @class */ (function () {
    function CurrentYearComponent() {
    }
    /**
     * @return {?}
     */
    CurrentYearComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.year = (new Date()).getFullYear();
    };
    CurrentYearComponent.decorators = [
        { type: Component, args: [{
                    selector: 'lib-current-year',
                    template: '{{year}}'
                }] }
    ];
    /** @nocollapse */
    CurrentYearComponent.ctorParameters = function () { return []; };
    return CurrentYearComponent;
}());
if (false) {
    /** @type {?} */
    CurrentYearComponent.prototype.year;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/components/config-info/config-info.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ConfigInfoComponent = /** @class */ (function () {
    function ConfigInfoComponent() {
    }
    /**
     * @return {?}
     */
    ConfigInfoComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    ConfigInfoComponent.decorators = [
        { type: Component, args: [{
                    selector: 'lib-config-info',
                    template: ''
                }] }
    ];
    /** @nocollapse */
    ConfigInfoComponent.ctorParameters = function () { return []; };
    return ConfigInfoComponent;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: lib/components/signup-two/signup-two.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var SignupTwoComponent = /** @class */ (function () {
    function SignupTwoComponent(fb, route, configInfoService, validationService) {
        this.fb = fb;
        this.route = route;
        this.configInfoService = configInfoService;
        this.validationService = validationService;
        this.country = this.route.snapshot.routeConfig.path.toUpperCase();
        this.signupForm = this.fb.group({
            'prospect': this.fb.group({
                'firstName': ['', [Validators.required, ValidationFormService.firstNameValidator, Validators.minLength(2), Validators.maxLength(255)]],
                'lastName': ['', [Validators.required, ValidationFormService.lastNameValidator, Validators.minLength(2), Validators.maxLength(255)]],
                'phone': ['', [Validators.required, Validators.minLength(6), Validators.maxLength(20)]],
                'email': ['', [Validators.required, Validators.email, ValidationFormService.emailValidator, Validators.minLength(4), Validators.maxLength(255)]],
                'address': this.fb.group({
                    'postcode': ['', [Validators.required, Validators.minLength(2), Validators.maxLength(20)]],
                    'street': ['', [Validators.required, Validators.minLength(2), Validators.maxLength(255)]],
                    'state': ['', [Validators.required, Validators.minLength(2), Validators.maxLength(255)]],
                    'country': [this.country],
                })
            })
        });
    }
    /**
     * @return {?}
     */
    SignupTwoComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.country = this.route.snapshot.routeConfig.path.toUpperCase();
        this.preFiledInfo();
    };
    /**
     * @return {?}
     */
    SignupTwoComponent.prototype.preFiledInfo = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var config = JSON.parse(localStorage.getItem('config'));
        if (config !== null && config !== '' && config.prospect) {
            this.signupForm.controls.prospect.patchValue({
                "firstName": this.configInfoService.getConfigInfo('prospect', 'firstName'),
                "lastName": this.configInfoService.getConfigInfo('prospect', 'lastName'),
                "phone": this.configInfoService.getConfigInfo('prospect', 'phone'),
                "email": this.configInfoService.getConfigInfo('prospect', 'email'),
                "address": {
                    "postcode": this.configInfoService.getConfigInfo('prospect', 'address', 'postcode'),
                    "street": this.configInfoService.getConfigInfo('prospect', 'address', 'street'),
                    "state": this.configInfoService.getConfigInfo('prospect', 'address', 'state')
                }
            });
        }
    };
    /**
     * @return {?}
     */
    SignupTwoComponent.prototype.patchSession = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.errorMessage = null;
        this.sessionId = this.configInfoService.getConfigInfo('id');
        if (this.signupForm.dirty && this.signupForm.valid && this.validationService.checkHistoryEmail(this.signupForm) === true) {
            this.validationService.verifAndPatchSession(this.signupForm, this.sessionId).subscribe((/**
             * @param {?} session
             * @return {?}
             */
            function (session) {
                /** @type {?} */
                var redirectionUrl = _this.configInfoService.getConfigInfo('campaign', 'offers', [0], 'brands', [1], 'domain');
                window.location.href = "https://" + redirectionUrl + "/payment/" + _this.sessionId;
            }), (/**
             * @param {?} error
             * @return {?}
             */
            function (error) {
                _this.errorMessage = error;
            }));
        }
        else
            this.errorMessage = 'An error occurred';
    };
    SignupTwoComponent.decorators = [
        { type: Component, args: [{
                    selector: 'lib-signup-two',
                    template: "<div class=\"form-signup-two-wrapper\">\n  <form [formGroup]=\"signupForm\" (ngSubmit)=\"patchSession()\" class=\"form form-signup-two\">\n    <div formGroupName=\"prospect\" class=\"prospect-wrapper\">\n      <div class=\"name-group field-group\">\n        <div class=\"first-name field form-group\">\n          <label for=\"firstName\" class=\"first-name-label label\">{{ 'signup.label.firstname' | translate }}</label>\n          <input type=\"text\" class=\"first-name-input form-control\" id=\"firstName\" placeholder=\"{{ 'signup.placeholder.firstname' | translate }}\" formControlName=\"firstName\" required>\n          <lib-control-messages [control]=\"signupForm.get(['prospect', 'firstName'])\"></lib-control-messages>\n        </div>\n        <div class=\"lastName form-group field\">\n          <label for=\"lastName\" class=\"last-name-label label\">{{ 'signup.label.lastname' | translate }}</label>\n          <input type=\"text\" class=\"last-name-input form-control\" id=\"lastName\" placeholder=\"{{ 'signup.placeholder.lastname' | translate }}\" formControlName=\"lastName\" required>\n          <lib-control-messages [control]=\"signupForm.get(['prospect', 'lastName'])\"></lib-control-messages>\n        </div>\n      </div>\n      <div formGroupName=\"address\" class=\"address-group field-group\">\n        <div class=\"address form-group field\">\n          <label for=\"street\" class=\"address-label label\">{{ 'signup.label.address' | translate }}</label>\n          <input type=\"text\" class=\"address-input form-control\" id=\"street\" placeholder=\"{{ 'signup.placeholder.address' | translate }}\" formControlName=\"street\" required specialIsAlphaNumeric>\n          <lib-control-messages [control]=\"signupForm.get(['prospect', 'address', 'street'])\"></lib-control-messages>\n        </div>\n        <div class=\"postcode form-group field\">\n          <label for=\"postcode\" class=\"postcode-label label\">{{ 'signup.label.postcode' | translate }}</label>\n          <input type=\"text\" class=\"postcode-input form-control\" id=\"postcode\" placeholder=\"{{ 'signup.placeholder.postcode' | translate }}\" formControlName=\"postcode\" required specialIsAlphaNumeric>\n          <lib-control-messages [control]=\"signupForm.get(['prospect', 'address', 'postcode'])\"></lib-control-messages>\n        </div>\n        <div class=\"state form-group field\">\n          <label for=\"state\" class=\"state-label label\">{{ 'signup.label.state' | translate }}</label>\n          <input type=\"text\" class=\"state-input form-control\" id=\"state\" placeholder=\"{{ 'signup.placeholder.state' | translate }}\" formControlName=\"state\" required specialIsAlphaNumeric>\n          <lib-control-messages [control]=\"signupForm.get(['prospect', 'address', 'state'])\"></lib-control-messages>\n        </div>\n      </div>\n      <div class=\"contact-group field-group\">\n        <div class=\"phone form-group field\">\n          <label for=\"phone\" class=\"phone-label label\">{{ 'signup.label.phone' | translate }}</label>\n          <input type=\"text\" class=\"phone-input form-control\" id=\"phone\" placeholder=\"{{ 'signup.placeholder.phone' | translate }}\" formControlName=\"phone\" required phoneNumeric>\n          <lib-control-messages [control]=\"signupForm.get(['prospect', 'phone'])\"></lib-control-messages>\n        </div>\n        <div class=\"email form-group field\">\n          <label for=\"email\" class=\"email-label label\">{{ 'signup.label.email' | translate }}</label>\n          <input type=\"text\" class=\"email-input form-control\" id=\"email\" placeholder=\"{{ 'signup.placeholder.email' | translate }}\" formControlName=\"email\" required>\n          <lib-control-messages [control]=\"signupForm.get(['prospect', 'email'])\"></lib-control-messages>\n        </div>\n      </div>\n      <div class=\"buttons form-group field-submit\">\n        <button type=\"submit\" class=\"button button-submit\" [disabled]=\"!signupForm.valid\">{{ 'signup.button' | translate }}</button>\n      </div>\n    </div>\n  </form>\n</div>\n",
                    styles: ["button{width:100%}"]
                }] }
    ];
    /** @nocollapse */
    SignupTwoComponent.ctorParameters = function () { return [
        { type: FormBuilder },
        { type: ActivatedRoute },
        { type: ConfigInfoService },
        { type: ValidationFormService }
    ]; };
    return SignupTwoComponent;
}());
if (false) {
    /** @type {?} */
    SignupTwoComponent.prototype.sessionId;
    /** @type {?} */
    SignupTwoComponent.prototype.session;
    /** @type {?} */
    SignupTwoComponent.prototype.country;
    /** @type {?} */
    SignupTwoComponent.prototype.errorMessage;
    /** @type {?} */
    SignupTwoComponent.prototype.signupForm;
    /**
     * @type {?}
     * @private
     */
    SignupTwoComponent.prototype.fb;
    /**
     * @type {?}
     * @private
     */
    SignupTwoComponent.prototype.route;
    /**
     * @type {?}
     * @private
     */
    SignupTwoComponent.prototype.configInfoService;
    /**
     * @type {?}
     * @private
     */
    SignupTwoComponent.prototype.validationService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/components/signup-three/signup-three.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var SignupThreeComponent = /** @class */ (function () {
    function SignupThreeComponent(fb, route, configInfoService, validationService) {
        this.fb = fb;
        this.route = route;
        this.configInfoService = configInfoService;
        this.validationService = validationService;
        this.country = this.route.snapshot.routeConfig.path.toUpperCase();
        this.signupForm = this.fb.group({
            'prospect': this.fb.group({
                'firstName': ['', [Validators.required, ValidationFormService.firstNameValidator, Validators.minLength(2), Validators.maxLength(255)]],
                'lastName': ['', [Validators.required, ValidationFormService.lastNameValidator, Validators.minLength(2), Validators.maxLength(255)]],
                'phone': ['', [Validators.required, Validators.minLength(6), Validators.maxLength(20)]],
                'email': ['', [Validators.required, Validators.email, ValidationFormService.emailValidator, Validators.minLength(4), Validators.maxLength(255)]],
                'address': this.fb.group({
                    'city': ['', [Validators.required, ValidationFormService.cityValidator, Validators.minLength(2), Validators.maxLength(255)]],
                    'street': ['', [Validators.required, Validators.minLength(2), Validators.maxLength(255)]],
                    'country': [this.country],
                    'state': ['', [Validators.required, Validators.minLength(2), Validators.maxLength(255)]]
                })
            })
        });
    }
    /**
     * @return {?}
     */
    SignupThreeComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.country = this.route.snapshot.routeConfig.path.toUpperCase();
        this.preFiledInfo();
    };
    /**
     * @return {?}
     */
    SignupThreeComponent.prototype.preFiledInfo = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var config = JSON.parse(localStorage.getItem('config'));
        if (config !== null && config !== '' && config.prospect) {
            this.signupForm.controls.prospect.patchValue({
                "firstName": this.configInfoService.getConfigInfo('prospect', 'firstName'),
                "lastName": this.configInfoService.getConfigInfo('prospect', 'lastName'),
                "phone": this.configInfoService.getConfigInfo('prospect', 'phone'),
                "email": this.configInfoService.getConfigInfo('prospect', 'email'),
                "address": {
                    "city": this.configInfoService.getConfigInfo('prospect', 'address', 'city'),
                    "street": this.configInfoService.getConfigInfo('prospect', 'address', 'street'),
                    "state": this.configInfoService.getConfigInfo('prospect', 'address', 'state')
                }
            });
        }
    };
    /**
     * @return {?}
     */
    SignupThreeComponent.prototype.patchSession = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.errorMessage = null;
        this.sessionId = this.configInfoService.getConfigInfo('id');
        if (this.signupForm.dirty && this.signupForm.valid && this.validationService.checkHistoryEmail(this.signupForm) === true) {
            this.validationService.verifAndPatchSession(this.signupForm, this.sessionId).subscribe((/**
             * @param {?} session
             * @return {?}
             */
            function (session) {
                /** @type {?} */
                var redirectionUrl = _this.configInfoService.getConfigInfo('campaign', 'offers', [0], 'brands', [1], 'domain');
                window.location.href = "https://" + redirectionUrl + "/payment/" + _this.sessionId;
            }), (/**
             * @param {?} error
             * @return {?}
             */
            function (error) {
                _this.errorMessage = error;
            }));
        }
        else
            this.errorMessage = 'An error occurred';
    };
    SignupThreeComponent.decorators = [
        { type: Component, args: [{
                    selector: 'lib-signup-three',
                    template: "<div class=\"form-signup-three-wrapper\">\n  <form [formGroup]=\"signupForm\" (ngSubmit)=\"patchSession()\" class=\"form form-signup-three\">\n    <div formGroupName=\"prospect\" class=\"prospect-wrapper\">\n      <div class=\"name-group field-group\">\n        <div class=\"first-name field form-group\">\n          <label for=\"firstName\" class=\"first-name-label label\">{{ 'signup.label.firstname' | translate }}</label>\n          <input type=\"text\" class=\"first-name-input form-control\" id=\"firstName\" placeholder=\"{{ 'signup.placeholder.firstname' | translate }}\" formControlName=\"firstName\" required>\n          <lib-control-messages [control]=\"signupForm.get(['prospect', 'firstName'])\"></lib-control-messages>\n        </div>\n        <div class=\"lastName form-group field\">\n          <label for=\"lastName\" class=\"last-name-label label\">{{ 'signup.label.lastname' | translate }}</label>\n          <input type=\"text\" class=\"last-name-input form-control\" id=\"lastName\" placeholder=\"{{ 'signup.placeholder.lastname' | translate }}\" formControlName=\"lastName\" required>\n          <lib-control-messages [control]=\"signupForm.get(['prospect', 'lastName'])\"></lib-control-messages>\n        </div>\n      </div>\n      <div formGroupName=\"address\" class=\"address-group field-group\">\n        <div class=\"address form-group field\">\n          <label for=\"street\" class=\"address-label label\">{{ 'signup.label.address' | translate }}</label>\n          <input type=\"text\" class=\"address-input form-control\" id=\"street\" placeholder=\"{{ 'signup.placeholder.address' | translate }}\" formControlName=\"street\" required specialIsAlphaNumeric>\n          <lib-control-messages [control]=\"signupForm.get(['prospect', 'address', 'street'])\"></lib-control-messages>\n        </div>\n        <div class=\"field\">\n          <div class=\"city-wrapper\">\n            <label for=\"city\" class=\"label\">{{ 'signup.label.city' | translate }}:</label>\n            <input type=\"text\" class=\"form-control\" id=\"city\" placeholder=\"{{ 'signup.placeholder.city' | translate }}\" formControlName=\"city\" specialIsAlphaNumeric required>\n            <lib-control-messages [control]=\"signupForm.get(['prospect', 'address', 'city'])\"></lib-control-messages>\n          </div>\n      </div>\n        <div class=\"state form-group field\">\n          <label for=\"state\" class=\"state-label label\">{{ 'signup.label.state' | translate }}</label>\n          <input type=\"text\" class=\"state-input form-control\" id=\"state\" placeholder=\"{{ 'signup.placeholder.state' | translate }}\" formControlName=\"state\" required specialIsAlphaNumeric>\n          <lib-control-messages [control]=\"signupForm.get(['prospect', 'address', 'state'])\"></lib-control-messages>\n        </div>\n      </div>\n      <div class=\"contact-group field-group\">\n        <div class=\"phone form-group field\">\n          <label for=\"phone\" class=\"phone-label label\">{{ 'signup.label.phone' | translate }}</label>\n          <input type=\"text\" class=\"phone-input form-control\" id=\"phone\" placeholder=\"{{ 'signup.placeholder.phone' | translate }}\" formControlName=\"phone\" required phoneNumeric>\n          <lib-control-messages [control]=\"signupForm.get(['prospect', 'phone'])\"></lib-control-messages>\n        </div>\n        <div class=\"email form-group field\">\n          <label for=\"email\" class=\"email-label label\">{{ 'signup.label.email' | translate }}</label>\n          <input type=\"text\" class=\"email-input form-control\" id=\"email\" placeholder=\"{{ 'signup.placeholder.email' | translate }}\" formControlName=\"email\" required>\n          <lib-control-messages [control]=\"signupForm.get(['prospect', 'email'])\"></lib-control-messages>\n        </div>\n      </div>\n      <div class=\"buttons form-group field-submit\">\n        <button type=\"submit\" class=\"button button-submit\" [disabled]=\"!signupForm.valid\">{{ 'signup.button' | translate }}</button>\n      </div>\n    </div>\n  </form>\n</div>\n",
                    styles: ["button{width:100%}"]
                }] }
    ];
    /** @nocollapse */
    SignupThreeComponent.ctorParameters = function () { return [
        { type: FormBuilder },
        { type: ActivatedRoute },
        { type: ConfigInfoService },
        { type: ValidationFormService }
    ]; };
    return SignupThreeComponent;
}());
if (false) {
    /** @type {?} */
    SignupThreeComponent.prototype.sessionId;
    /** @type {?} */
    SignupThreeComponent.prototype.session;
    /** @type {?} */
    SignupThreeComponent.prototype.country;
    /** @type {?} */
    SignupThreeComponent.prototype.errorMessage;
    /** @type {?} */
    SignupThreeComponent.prototype.signupForm;
    /**
     * @type {?}
     * @private
     */
    SignupThreeComponent.prototype.fb;
    /**
     * @type {?}
     * @private
     */
    SignupThreeComponent.prototype.route;
    /**
     * @type {?}
     * @private
     */
    SignupThreeComponent.prototype.configInfoService;
    /**
     * @type {?}
     * @private
     */
    SignupThreeComponent.prototype.validationService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/components/signup-four/signup-four.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var SignupFourComponent = /** @class */ (function () {
    function SignupFourComponent(fb, route, validationService, configInfoService) {
        this.fb = fb;
        this.route = route;
        this.validationService = validationService;
        this.configInfoService = configInfoService;
        this.country = this.route.snapshot.routeConfig.path.toUpperCase();
        this.signupForm = this.fb.group({
            'prospect': this.fb.group({
                'firstName': ['', [Validators.required, ValidationFormService.firstNameValidator, Validators.minLength(2), Validators.maxLength(255)]],
                'lastName': ['', [Validators.required, ValidationFormService.lastNameValidator, Validators.minLength(2), Validators.maxLength(255)]],
                'phone': ['', [Validators.required, Validators.minLength(6), Validators.maxLength(20)]],
                'email': ['', [Validators.required, Validators.email, ValidationFormService.emailValidator, Validators.minLength(4), Validators.maxLength(255)]],
                'address': this.fb.group({
                    'postcode': ['', [Validators.required, Validators.minLength(2), Validators.maxLength(20)]],
                    'city': ['', [Validators.required, ValidationFormService.cityValidator, Validators.minLength(2), Validators.maxLength(255)]],
                    'street': ['', [Validators.required, Validators.minLength(2), Validators.maxLength(255)]],
                    'country': [this.country],
                    'state': ['', [Validators.required, Validators.minLength(2), Validators.maxLength(255)]]
                })
            })
        });
    }
    /**
     * @return {?}
     */
    SignupFourComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.country = this.route.snapshot.routeConfig.path.toUpperCase();
        this.preFiledInfo();
    };
    /**
     * @return {?}
     */
    SignupFourComponent.prototype.preFiledInfo = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var config = JSON.parse(localStorage.getItem('config'));
        if (config !== null && config !== '' && config.prospect) {
            this.signupForm.controls.prospect.patchValue({
                "firstName": this.configInfoService.getConfigInfo('prospect', 'firstName'),
                "lastName": this.configInfoService.getConfigInfo('prospect', 'lastName'),
                "phone": this.configInfoService.getConfigInfo('prospect', 'phone'),
                "email": this.configInfoService.getConfigInfo('prospect', 'email'),
                "address": {
                    "city": this.configInfoService.getConfigInfo('prospect', 'address', 'city'),
                    "postcode": this.configInfoService.getConfigInfo('prospect', 'address', 'postcode'),
                    "street": this.configInfoService.getConfigInfo('prospect', 'address', 'street'),
                    "state": this.configInfoService.getConfigInfo('prospect', 'address', 'state')
                }
            });
        }
    };
    /**
     * @return {?}
     */
    SignupFourComponent.prototype.patchSession = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.errorMessage = null;
        this.sessionId = this.configInfoService.getConfigInfo('id');
        if (this.signupForm.dirty && this.signupForm.valid && this.validationService.checkHistoryEmail(this.signupForm) === true) {
            this.validationService.verifAndPatchSession(this.signupForm, this.sessionId).subscribe((/**
             * @param {?} session
             * @return {?}
             */
            function (session) {
                /** @type {?} */
                var redirectionUrl = _this.configInfoService.getConfigInfo('campaign', 'offers', [0], 'brands', [1], 'domain');
                window.location.href = "https://" + redirectionUrl + "/payment/" + _this.sessionId;
            }), (/**
             * @param {?} error
             * @return {?}
             */
            function (error) {
                _this.errorMessage = error;
            }));
        }
        else
            this.errorMessage = 'An error occurred';
    };
    SignupFourComponent.decorators = [
        { type: Component, args: [{
                    selector: 'lib-signup-four',
                    template: "<div class=\"signup-wrapper signup-four\">\n  <form [formGroup]=\"signupForm\" (ngSubmit)=\"patchSession()\" class=\"signup-form\">\n    <div formGroupName=\"prospect\" class=\"prospect-wrapper\">\n      <div class=\"signup-four-wrapper\">\n        <div class=\"field\">\n          <div class=\"firstName-wrapper\">\n            <label for=\"firstName\" class=\"label\">{{ 'signup.label.firstname' | translate }}:</label>\n            <input type=\"text\" class=\"form-control\" id=\"firstName\" placeholder=\"{{ 'signup.placeholder.firstname' | translate }}\" formControlName=\"firstName\" required>\n            <lib-control-messages [control]=\"signupForm.get(['prospect', 'firstName'])\"></lib-control-messages>\n          </div>\n        </div>\n        <div class=\"field\">\n          <div class=\"lastName-wrapper\">\n            <label for=\"lastName\" class=\"label\">{{ 'signup.label.lastname' | translate }}:</label>\n            <input type=\"text\" class=\"form-control\" id=\"lastName\" placeholder=\"{{ 'signup.placeholder.lastname' | translate }}\" formControlName=\"lastName\" required>\n            <lib-control-messages [control]=\"signupForm.get(['prospect', 'lastName'])\"></lib-control-messages>\n          </div>\n        </div>\n        <div formGroupName=\"address\" class=\"address-wrapper\">\n          <div class=\"field\">\n            <div class=\"address-wrapper\">\n              <label for=\"street\" class=\"label\">{{ 'signup.label.address' | translate }}:</label>\n              <input type=\"text\" class=\"form-control\" id=\"street\" placeholder=\"{{ 'signup.placeholder.address' | translate }}\" formControlName=\"street\" required specialIsAlphaNumeric>\n              <lib-control-messages [control]=\"signupForm.get(['prospect', 'address', 'street'])\"></lib-control-messages>\n            </div>\n          </div>\n          <div class=\"field\">\n            <div class=\"postcode-wrapper\">\n              <label for=\"postcode\" class=\"label\">{{ 'signup.label.postcode' | translate }}:</label>\n              <input type=\"text\" class=\"form-control\" id=\"postcode\" placeholder=\"{{ 'signup.placeholder.postcode' | translate }}\" formControlName=\"postcode\" required specialIsAlphaNumeric>\n              <lib-control-messages [control]=\"signupForm.get(['prospect', 'address', 'postcode'])\"></lib-control-messages>\n            </div>\n          </div>\n          <div class=\"field\">\n            <div class=\"city-wrapper\">\n              <label for=\"city\" class=\"label\">{{ 'signup.label.city' | translate }}:</label>\n              <input type=\"text\" class=\"form-control\" id=\"city\" placeholder=\"{{ 'signup.placeholder.city' | translate }}\" formControlName=\"city\" required specialIsAlphaNumeric>\n              <lib-control-messages [control]=\"signupForm.get(['prospect', 'address', 'city'])\"></lib-control-messages>\n            </div>\n          </div>\n          <div class=\"field\">\n            <div class=\"state-wrapper\">\n              <label for=\"state\" class=\"label\">{{ 'signup.label.state' | translate }}:</label>\n              <input type=\"text\" class=\"form-control\" id=\"state\" placeholder=\"{{ 'signup.placeholder.state' | translate }}\" formControlName=\"state\" required specialIsAlphaNumeric>\n              <lib-control-messages [control]=\"signupForm.get(['prospect', 'address', 'state'])\"></lib-control-messages>\n            </div>\n          </div>\n        </div>\n        <div class=\"field\">\n          <div class=\"phone-wrapper\">\n            <label for=\"phone\" class=\"label\">{{ 'signup.label.phone' | translate }}:</label>\n            <input type=\"text\" class=\"form-control\" id=\"phone\" placeholder=\"{{ 'signup.placeholder.phone' | translate }}\" formControlName=\"phone\" required phoneNumeric>\n            <lib-control-messages [control]=\"signupForm.get(['prospect', 'phone'])\"></lib-control-messages>\n          </div>\n        </div>\n        <div class=\"field\">\n          <div class=\"email-wrapper\">\n            <label for=\"email\" class=\"label\">{{ 'signup.label.email' | translate }}:</label>\n            <input type=\"text\" class=\"form-control\" id=\"email\" placeholder=\"{{ 'signup.placeholder.email' | translate }}\" formControlName=\"email\" required>\n            <lib-control-messages [control]=\"signupForm.get(['prospect', 'email'])\"></lib-control-messages>\n          </div>\n        </div>\n        <div class=\"error-message\">\n          <p>{{errorMessage}}</p>\n        </div>\n        <div class=\"field\">\n          <div class=\"button-wrapper\">\n            <button type=\"submit\" class=\"btn btn-success\" [disabled]=\"!signupForm.valid\">{{ 'signup.button' | translate }}</button>\n          </div>\n        </div>\n      </div>\n    </div>\n  </form>\n</div>\n",
                    styles: ["button{width:100%}"]
                }] }
    ];
    /** @nocollapse */
    SignupFourComponent.ctorParameters = function () { return [
        { type: FormBuilder },
        { type: ActivatedRoute },
        { type: ValidationFormService },
        { type: ConfigInfoService }
    ]; };
    return SignupFourComponent;
}());
if (false) {
    /** @type {?} */
    SignupFourComponent.prototype.sessionId;
    /** @type {?} */
    SignupFourComponent.prototype.session;
    /** @type {?} */
    SignupFourComponent.prototype.country;
    /** @type {?} */
    SignupFourComponent.prototype.errorMessage;
    /** @type {?} */
    SignupFourComponent.prototype.signupForm;
    /**
     * @type {?}
     * @private
     */
    SignupFourComponent.prototype.fb;
    /**
     * @type {?}
     * @private
     */
    SignupFourComponent.prototype.route;
    /**
     * @type {?}
     * @private
     */
    SignupFourComponent.prototype.validationService;
    /**
     * @type {?}
     * @private
     */
    SignupFourComponent.prototype.configInfoService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/components/terms/terms.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var TermsComponent = /** @class */ (function () {
    function TermsComponent(configInfoService) {
        this.configInfoService = configInfoService;
    }
    /**
     * @return {?}
     */
    TermsComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        // this.getInitialPeriod();
        this.getCurrency();
        this.getInitialPrice();
        // this.getReBillPeriod();
        this.getReBillPrice();
        this.getCurrentYear();
    };
    /**
     * @return {?}
     */
    TermsComponent.prototype.getReBillPrice = /**
     * @return {?}
     */
    function () {
        this.reBillPrice = this.configInfoService.getConfigInfo('campaign', 'offers', [0], 'products', [0], 'installments', [1], 'price');
    };
    /**
     * @return {?}
     */
    TermsComponent.prototype.getInitialPeriod = /**
     * @return {?}
     */
    function () {
        this.initialPeriod = this.configInfoService.getConfigInfo('campaign', 'offers', [0], 'products', [0], 'installments', [0], 'cycle', 'count') + " \n    " + (this.initialPeriod += this.configInfoService.getConfigInfo('campaign', 'offers', [0], 'products', [0], 'installments', [0], 'cycle', 'type'));
    };
    /**
     * @return {?}
     */
    TermsComponent.prototype.getCurrency = /**
     * @return {?}
     */
    function () {
        this.currency = this.configInfoService.getConfigInfo('campaign', 'currency');
    };
    /**
     * @return {?}
     */
    TermsComponent.prototype.getReBillPeriod = /**
     * @return {?}
     */
    function () {
        this.reBillPeriod = this.configInfoService.getConfigInfo('campaign', 'offers', [0], 'products', [0], 'installments', [1], 'cycle', 'count') + " \n    " + (this.reBillPeriod += this.configInfoService.getConfigInfo('campaign', 'offers', [0], 'products', [0], 'installments', [1], 'cycle', 'type'));
    };
    /**
     * @return {?}
     */
    TermsComponent.prototype.getInitialPrice = /**
     * @return {?}
     */
    function () {
        this.initialPrice = this.configInfoService.getConfigInfo('campaign', 'offers', [0], 'products', [0], 'installments', [0], 'price');
    };
    /**
     * @return {?}
     */
    TermsComponent.prototype.getCurrentYear = /**
     * @return {?}
     */
    function () {
        this.currentYear = this.configInfoService.getCurrentYear();
    };
    TermsComponent.decorators = [
        { type: Component, args: [{
                    selector: 'lib-terms',
                    template: "<p class=\"terms\">{{ 'terms.text' | translate:{'initialPeriod':initialPeriod, 'currency': currency, 'initialPrice': initialPrice, 'reBillPeriod': reBillPeriod, 'reBillPrice': reBillPrice, 'currentYear': currentYear} }}</p>\n",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    TermsComponent.ctorParameters = function () { return [
        { type: ConfigInfoService }
    ]; };
    return TermsComponent;
}());
if (false) {
    /** @type {?} */
    TermsComponent.prototype.initialPeriod;
    /** @type {?} */
    TermsComponent.prototype.currency;
    /** @type {?} */
    TermsComponent.prototype.initialPrice;
    /** @type {?} */
    TermsComponent.prototype.reBillPeriod;
    /** @type {?} */
    TermsComponent.prototype.reBillPrice;
    /** @type {?} */
    TermsComponent.prototype.currentYear;
    /**
     * @type {?}
     * @private
     */
    TermsComponent.prototype.configInfoService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/components/control-message/control-message.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ControlMessagesComponent = /** @class */ (function () {
    function ControlMessagesComponent() {
    }
    Object.defineProperty(ControlMessagesComponent.prototype, "errorMessage", {
        get: /**
         * @return {?}
         */
        function () {
            for (var propertyName in this.control.errors) {
                if (this.control.errors.hasOwnProperty(propertyName) &&
                    this.control.touched) {
                    return propertyName;
                }
            }
            return null;
        },
        enumerable: true,
        configurable: true
    });
    ControlMessagesComponent.decorators = [
        { type: Component, args: [{
                    selector: 'lib-control-messages',
                    template: "\n    <div *ngIf=\"errorMessage !== null\">{{'signup.errors.'+errorMessage | translate:{'minlength' : this.control.errors[errorMessage].requiredLength} }}</div>\n  "
                }] }
    ];
    /** @nocollapse */
    ControlMessagesComponent.ctorParameters = function () { return []; };
    ControlMessagesComponent.propDecorators = {
        control: [{ type: Input }]
    };
    return ControlMessagesComponent;
}());
if (false) {
    /** @type {?} */
    ControlMessagesComponent.prototype.control;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/directives/validation/numeric.directive.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NumericDirective = /** @class */ (function () {
    function NumericDirective(elRef, renderer, control) {
        this.elRef = elRef;
        this.renderer = renderer;
        this.control = control;
        this.regexStr = '^[0-9]+(?:[\w -]*[0-9]+)*$';
    }
    /**
     * @param {?} event
     * @return {?}
     */
    NumericDirective.prototype.onKeyPress = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        return new RegExp(this.regexStr).test(event.key);
    };
    /**
     * @param {?} event
     * @return {?}
     */
    NumericDirective.prototype.onPaste = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        event.preventDefault();
        this.control.control
            .setValue(event.clipboardData
            .getData('text/plain')
            .replace(/\D/g, ''));
    };
    NumericDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[NumericCharacters]'
                },] }
    ];
    /** @nocollapse */
    NumericDirective.ctorParameters = function () { return [
        { type: ElementRef },
        { type: Renderer2 },
        { type: NgControl }
    ]; };
    NumericDirective.propDecorators = {
        onKeyPress: [{ type: HostListener, args: ['keypress', ['$event'],] }],
        onPaste: [{ type: HostListener, args: ['paste', ['$event'],] }]
    };
    return NumericDirective;
}());
if (false) {
    /** @type {?} */
    NumericDirective.prototype.regexStr;
    /**
     * @type {?}
     * @private
     */
    NumericDirective.prototype.elRef;
    /**
     * @type {?}
     * @private
     */
    NumericDirective.prototype.renderer;
    /**
     * @type {?}
     * @private
     */
    NumericDirective.prototype.control;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/directives/validation/phone.directive.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var PhoneDirective = /** @class */ (function () {
    function PhoneDirective(elRef, renderer, control) {
        this.elRef = elRef;
        this.renderer = renderer;
        this.control = control;
        this.regexStr = '^[+0-9]+(?:[\w -]*[0-9]+)*$';
    }
    /**
     * @param {?} event
     * @return {?}
     */
    PhoneDirective.prototype.onKeyPress = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        return new RegExp(this.regexStr).test(event.key);
    };
    /**
     * @param {?} event
     * @return {?}
     */
    PhoneDirective.prototype.onPaste = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        event.preventDefault();
        this.control.control
            .setValue(event.clipboardData
            .getData('text/plain')
            .replace(/[^+0-9]/g, ''));
    };
    PhoneDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[phoneNumeric]'
                },] }
    ];
    /** @nocollapse */
    PhoneDirective.ctorParameters = function () { return [
        { type: ElementRef },
        { type: Renderer2 },
        { type: NgControl }
    ]; };
    PhoneDirective.propDecorators = {
        onKeyPress: [{ type: HostListener, args: ['keypress', ['$event'],] }],
        onPaste: [{ type: HostListener, args: ['paste', ['$event'],] }]
    };
    return PhoneDirective;
}());
if (false) {
    /** @type {?} */
    PhoneDirective.prototype.regexStr;
    /**
     * @type {?}
     * @private
     */
    PhoneDirective.prototype.elRef;
    /**
     * @type {?}
     * @private
     */
    PhoneDirective.prototype.renderer;
    /**
     * @type {?}
     * @private
     */
    PhoneDirective.prototype.control;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/directives/validation/alpha-numeric.directive.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var SpecialCharacterDirective = /** @class */ (function () {
    function SpecialCharacterDirective(elRef, renderer, control) {
        this.elRef = elRef;
        this.renderer = renderer;
        this.control = control;
        this.regexStr = '^[a-zA-Z0-9_ ]+(?:[\w -]*[a-zA-Z0-9]+)*$';
    }
    /**
     * @param {?} event
     * @return {?}
     */
    SpecialCharacterDirective.prototype.onKeyPress = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        return new RegExp(this.regexStr).test(event.key);
    };
    /**
     * @param {?} event
     * @return {?}
     */
    SpecialCharacterDirective.prototype.onPaste = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        event.preventDefault();
        this.control.control
            .setValue(event.clipboardData
            .getData('text/plain')
            .replace(/[^A-Za-z0-9 ]/g, ' ')
            .replace(/\s/g, ' '));
    };
    SpecialCharacterDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[specialIsAlphaNumeric]'
                },] }
    ];
    /** @nocollapse */
    SpecialCharacterDirective.ctorParameters = function () { return [
        { type: ElementRef },
        { type: Renderer2 },
        { type: NgControl }
    ]; };
    SpecialCharacterDirective.propDecorators = {
        onKeyPress: [{ type: HostListener, args: ['keypress', ['$event'],] }],
        onPaste: [{ type: HostListener, args: ['paste', ['$event'],] }]
    };
    return SpecialCharacterDirective;
}());
if (false) {
    /** @type {?} */
    SpecialCharacterDirective.prototype.regexStr;
    /**
     * @type {?}
     * @private
     */
    SpecialCharacterDirective.prototype.elRef;
    /**
     * @type {?}
     * @private
     */
    SpecialCharacterDirective.prototype.renderer;
    /**
     * @type {?}
     * @private
     */
    SpecialCharacterDirective.prototype.control;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/components/countdown/countdown.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CountdownComponent = /** @class */ (function () {
    function CountdownComponent() {
        this.setHours = 0;
        this.setMinutes = 0;
        this.finishedMessage = 'Offer ended';
        this.hideLabels = true;
        this.counterFinished = false;
    }
    /**
     * @return {?}
     */
    CountdownComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.counter();
    };
    /**
     * @return {?}
     */
    CountdownComponent.prototype.counter = /**
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var date = new Date;
        /** @type {?} */
        var countHours = Math.floor(this.setHours * (1000 * 60 * 60));
        /** @type {?} */
        var countMinutes = Math.floor(this.setMinutes * (1000 * 60));
        /** @type {?} */
        var endTime = date.setTime(date.getTime() + countHours + countMinutes);
        /** @type {?} */
        var x = setInterval((/**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var n = new Date().getTime();
            _this.count = endTime - n;
            _this.hours = Math.floor((_this.count / (1000 * 60 * 60)) % 24);
            _this.minutes = Math.floor((_this.count / 1000 / 60) % 60);
            _this.seconds = Math.floor((_this.count / 1000) % 60);
            if (_this.count <= 0) {
                clearInterval(x);
                _this.counterFinished = true;
            }
        }), 1000);
    };
    CountdownComponent.decorators = [
        { type: Component, args: [{
                    selector: 'lib-countdown',
                    template: "<div *ngIf=\"counterFinished; else notFinished\" class=\"countdown\">\n    <div class=\"countdown-inner\">\n        <div class=\"countdown-message\">{{finishedMessage}}</div>\n    </div>\n</div>\n<ng-template #notFinished>\n<div class=\"countdown\">\n    <div class=\"countdown-inner\">        \n        <div *ngIf=\"setHours\" class=\"countdown-count countdown-count-hours\">\n            <div *ngIf=\"hideLabels\" class=\"countdown-count-label\">hours</div>\n            <div class=\"countdown-count-value\">{{hours | number : '2.0'}}</div>\n        </div>\n        <div class=\"countdown-count countdown-count-minutes\">\n            <div *ngIf=\"hideLabels\" class=\"countdown-count-label\">minutes</div>\n            <div class=\"countdown-count-value\">{{minutes | number : '2.0'}}</div>\n        </div>\n        <div class=\"countdown-count countdown-count-seconds\">\n            <div *ngIf=\"hideLabels\" class=\"countdown-count-label\">seconds</div>\n            <div class=\"countdown-count-value\">{{seconds | number : '2.0'}}</div>\n        </div>\n    </div>    \n</div>\n</ng-template>",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    CountdownComponent.ctorParameters = function () { return []; };
    CountdownComponent.propDecorators = {
        setHours: [{ type: Input }],
        setMinutes: [{ type: Input }],
        finishedMessage: [{ type: Input }],
        hideLabels: [{ type: Input }]
    };
    return CountdownComponent;
}());
if (false) {
    /** @type {?} */
    CountdownComponent.prototype.setHours;
    /** @type {?} */
    CountdownComponent.prototype.setMinutes;
    /** @type {?} */
    CountdownComponent.prototype.finishedMessage;
    /** @type {?} */
    CountdownComponent.prototype.hideLabels;
    /** @type {?} */
    CountdownComponent.prototype.counterFinished;
    /** @type {?} */
    CountdownComponent.prototype.hours;
    /** @type {?} */
    CountdownComponent.prototype.minutes;
    /** @type {?} */
    CountdownComponent.prototype.seconds;
    /** @type {?} */
    CountdownComponent.prototype.count;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/campaigns-core.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ɵ0 = environment;
var CampaignsCoreModule = /** @class */ (function () {
    function CampaignsCoreModule(utilsService) {
        this.utilsService = utilsService;
        this.utilsService.setConfigSession();
        this.utilsService.setDefaultTranslation();
        this.utilsService.setRoutClassOnBody();
        this.utilsService.setCakeParams();
    }
    CampaignsCoreModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [CampaignsCoreComponent, SignupComponent, InitialPeriodComponent, InitialPriceComponent, ReBillPriceComponent, ReBillPeriodComponent, CurrencyComponent, CurrentYearComponent, ConfigInfoComponent, SignupTwoComponent, SignupThreeComponent, SignupFourComponent, TermsComponent, ControlMessagesComponent, SpecialCharacterDirective, NumericDirective, PhoneDirective, SpecialCharacterDirective, CountdownComponent],
                    imports: [
                        CommonModule,
                        HttpClientModule,
                        TranslateModule.forRoot({
                            loader: {
                                provide: TranslateLoader,
                                useFactory: HttpLoaderFactory,
                                deps: [HttpClient]
                            }
                        }),
                        FormsModule,
                        ReactiveFormsModule
                    ],
                    exports: [CampaignsCoreComponent, SignupComponent, InitialPeriodComponent, InitialPriceComponent, ReBillPriceComponent, ReBillPeriodComponent, CurrencyComponent, CurrentYearComponent, SignupTwoComponent, SignupThreeComponent, SignupFourComponent, TermsComponent, CountdownComponent],
                    providers: [
                        {
                            provide: 'CompanyInfoService', useClass: CompanyInfoService
                        },
                        {
                            provide: 'ConfigInfoComponent', useClass: ConfigInfoComponent
                        },
                        {
                            provide: 'environment', useValue: ɵ0
                        }
                    ]
                },] }
    ];
    /** @nocollapse */
    CampaignsCoreModule.ctorParameters = function () { return [
        { type: UtilsService }
    ]; };
    return CampaignsCoreModule;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    CampaignsCoreModule.prototype.utilsService;
}
/**
 * @param {?} http
 * @return {?}
 */
function HttpLoaderFactory(http) {
    return new MultiTranslateHttpLoader(http, []);
}

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: campaigns-core.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { CampaignsCoreComponent, CampaignsCoreModule, CampaignsCoreService, CompanyInfoService, HttpLoaderFactory, SignupComponent as ɵa, ConfigInfoService as ɵb, SessionService as ɵc, UtilsService as ɵd, ValidationFormService as ɵe, InitialPeriodComponent as ɵf, InitialPriceComponent as ɵg, ReBillPriceComponent as ɵh, ReBillPeriodComponent as ɵi, CurrencyComponent as ɵj, CurrentYearComponent as ɵk, ConfigInfoComponent as ɵl, SignupTwoComponent as ɵm, SignupThreeComponent as ɵn, SignupFourComponent as ɵo, TermsComponent as ɵp, ControlMessagesComponent as ɵq, SpecialCharacterDirective as ɵr, NumericDirective as ɵs, PhoneDirective as ɵt, CountdownComponent as ɵu, environment as ɵv };
//# sourceMappingURL=campaigns-core.js.map
